#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void derivation()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	
	
	PrintXY(34,6,"Derivation",1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
					
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				derivation_cours();
	
			if(choix == 2)
				derivation_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(34,6,"Derivation",1);
			 }

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	

	}

	
}

void derivation_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(3,1);
	
	PrintXY(10,6,"Derivation : cours",1);

	while(maintien_fonction)
	{	
	
		 if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3  && position == 1)
		{
			choix += 1;
			choix_cours(choix,3);
			choix_cours(choix-1,3);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,3);
			choix_cours(choix+1,3);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,3);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,3);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(46,34,"Definition",0);
						break;
					case 2:
						PrintMini(28,34,"Fonctions usuelles",1);
						break;
					case 3:
						PrintMini(25,34,"Fonctions complexes",1);	
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 3;		//Nombre de pages predominant
			
			switch(choix)		//Affichage nom de la partie et determination du nombre de pages
			{
				case 1:
					PrintMini(46,4,"Definition",0);
					pages = 2;
					break;
				case 2:
					PrintMini(28,4,"Fonctions usuelles",1);
					break;
				case 3:
					PrintMini(25,4,"Fonctions complexes",1);	
					break;
			}
			
			if(choix != 1)		//Affichage des deux bandes noires
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,11+116*j,i,ML_BLACK);
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 14 ; i <51 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Si la fonction f est derivable",1);
									PrintMini(4,26,"en tout point d'abscisse x de I",1);
									PrintMini(4,34,"On dit que f est derivable sur",1);	
									PrintMini(4,42,"I et on note sa derive f'",1);
									break;
									
								case 2:
									PrintMini(4,18,"Si f' est positive sur I, alors",1);
									PrintMini(4,26,"f est croissante sur I",1);
									PrintMini(4,34,"Si f' est negative sur I, alors",1);
									PrintMini(4,42,"f est decroissante sur I",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"f'(x) est la derive de f(x) :",1);
									PrintMini(4,26,"f(x) = k : f'(x) = 0",1);
									PrintMini(4,34,"f(x) = x : f'(x) = 1",1);	
									PrintMini(4,42,"f(x) = ax + b : f'(x) = a",1);
									break;
								
								case 2:
									PrintMini(4,18,"f(x) = x  : f'(x) = nx",1);
									PrintMini(34,16,"n",1);
									PrintMini(87,16,"n-1",1);
									PrintMini(4,32,"f(x) =   : f'(x) = -",1);
									ML_line(29,34,34,34,ML_BLACK);
									PrintMini(30,28,"1",1);
									PrintMini(30,35,"x",1);
									ML_line(79,34,89,34,ML_BLACK);
									PrintMini(82,28,"1",1);
									PrintMini(80,38,"x",1);
									PrintMini(84,36,"2",1);
									break;
									
								case 3:
									PrintMini(4,18,"f(x) =",1);
									racine_carre(28,16,6);
									PrintMini(33,18,"x  : f'(x) = ",1);
									ML_line(81,20,95,20,ML_BLACK);
									PrintMini(86,14,"1",1);
									PrintMini(82,24,"2",1);
									racine_carre(86,22,6);
									PrintMini(91,24,"x",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"u et v sont derivables :",1);
									PrintMini(4,26,"(u + v)' = u' + v'",1);
									PrintMini(4,34,"(u * v)' = u' * v + u * v'",1);	
									PrintMini(4,42,"(u",1);
									PrintMini(16,42,")' = n * u' * u",1);
									PrintMini(11,40,"n",1);
									PrintMini(78,40,"n-1",1);
									break;
								
								case 2:
									parenthese(4,16,7);
									ML_line(7,24,12,24,ML_BLACK);
									PrintMini(8,18,"u",1);
									PrintMini(8,25,"v",1);
									PrintMini(16,16,"'",1);
									PrintMini(20,22,"=",1);
									ML_line(28,24,90,24,ML_BLACK);
									PrintMini(29,18,"u' * v - u * v'",1);
									PrintMini(58,28,"v",1);
									PrintMini(62,26,"2",1);
									parenthese(4,34,7);
									ML_line(7,42,12,42,ML_BLACK);
									PrintMini(8,36,"1",1);
									PrintMini(8,43,"u",1);
									PrintMini(16,34,"'",1);
									PrintMini(20,40,"= -",1);
									ML_line(36,42,45,42,ML_BLACK);
									PrintMini(38,36,"u'",1);
									PrintMini(37,46,"u",1);
									PrintMini(41,44,"2",1);
									break;
									
								case 3:
									PrintMini(4,18,"(   )' =",1);
									racine_carre(8,16,6);
									PrintMini(13,18,"u",1);
									ML_line(36,20,51,20,ML_BLACK);
									PrintMini(40,14,"u'",1);
									PrintMini(37,24,"2",1);
									racine_carre(41,22,6);
									PrintMini(46,24,"u",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(3,choix);
				PrintXY(10,6,"Derivation : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void derivation_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(9,6,"Deriv. : questions",1);
	
	question();
	
	for(i = 0 ; i < 20 ; i++)ML_line(2,47+i,47,47+i,ML_WHITE);
	
	case_question_derivation(2);
	case_question(1,2);
	
	affichage_question_derivation(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix == 1 && retour == 0)
		{
			choix = 2;
			
			case_question(1 , milieu);
			case_question(2,milieu);	
			affichage_question_derivation(2);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix == 2 && retour == 0)
		{
			choix = 1;
			
			case_question(2 , milieu);
			case_question(1 , milieu);
			affichage_question_derivation(1);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			switch(choix)
			{
				case 1:
					pages = 3;
					PrintMini(39,4,"Variation fonction",1);
					break;
				case 2:
					pages = 2;
					PrintMini(39,4,"Tangente",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <51 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour trouver les variations",1);
									PrintMini(4,22,"d'une fonction f(x), il faut",1);
									PrintMini(4,30,"trouver sa derive f'(x),",1);
									PrintMini(4,38,"resoudre f'(x) = 0 et faire ",1);
									PrintMini(4,46,"un tableau de variation",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : f(x) = 3x  + 5x + 4",1);
									PrintMini(80,14,"2",1);
									PrintMini(4,23,"f est defini et derivable sur",1);
									PrintMini(4,30,"|R avec f'(x) = 6x + 5",1);
									PrintMini(4,38,"f'(x) = 0 pour x = -(5/6)",1);
									break;
								
								case 3:
									PrintMini(4,14,"On a f'(x) > 0 pour x > (-5/6)",1);
									PrintMini(4,22,"et f'(x) < 0 pour x < -(5/6)",1);
									PrintMini(4,30,"Ainsi la fonction f est",1);
									PrintMini(4,38,"decroissante pour x < -(5/6)",1);
									PrintMini(4,46,"et croissante pour x > (-5/6)",1);
									break;
				
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"La tangente d'une fonction",1);
									PrintMini(4,22,"f en un point a est defini par",1);
									PrintMini(4,30,"la formule :",1);
									PrintMini(4,40,"T : y = f'(a)(x-a) + f(a)",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : f(x) = 3x  + 5x + 4",1);
									PrintMini(80,14,"2",1);
									PrintMini(4,23,"f'(x) = 6x + 5. La tangente de",1);
									PrintMini(4,30,"f au point 1 est :",1);
									PrintMini(4,38,"T : y = 11(x-1) + 12 = 11x + 1",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
		
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
				PrintXY(9,6,"Deriv. : questions",1);
	
				question();
			
				for(i = 0 ; i < 20 ; i++)ML_line(2,47+i,47,47+i,ML_WHITE);
			
				case_question_derivation(milieu);
				case_question(choix,milieu);
				affichage_question_derivation(choix);	
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_derivation(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	PrintMini(8,26,"Variation",0);
	PrintMini(9,38, "Tangente", 0);
}

void affichage_question_derivation(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Definir les",0);
			PrintMini(54,32,"variation",0);
			PrintMini(54,38,"d'une",0);
			PrintMini(54,44,"fonction",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"la tangente ",0);
			PrintMini(54,38,"d'une",0);
			PrintMini(54,44,"fonction",0);
			break;
			
	}
}