#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void estimation()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	
	
	PrintXY(34,6,"Estimation",1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
					
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				estimation_cours();
	
			if(choix == 2)
				estimation_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(34,6,"Estimation",1);
			 }

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	

	}

	
}

void estimation_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(3,1);
	
	PrintXY(10,6,"Estimation : cours",1);

	while(maintien_fonction)
	{	
	
		 if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3  && position == 1)
		{
			choix += 1;
			choix_cours(choix,3);
			choix_cours(choix-1,3);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,3);
			choix_cours(choix+1,3);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,3);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,3);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(9,34,"Theoreme de Moivre-Laplace",0);
						break;
					case 2:
						PrintMini(12,34,"Intervalles de fluctuation",1);
						break;
					case 3:
						PrintMini(14,34,"Intervalles de confiance",1);	
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 4;		//Nombre de pages predominant
			
			switch(choix)
			{
				case 1:
					pages = 2;
					PrintMini(45,4,"Theoreme",0);
					break;
				case 2:
					PrintMini(12,4,"Intervalles de fluctuation",1);
					break;
				case 3:
					PrintMini(14,4,"Intervalles de confiance",1);	
					break;
			}
			
			if(choix != 1)		//Affichage des deux bandes noires
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+118*j,i,8+118*j,i,ML_BLACK);
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 14 ; i <51 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Soit (Xn) une suite de variables",1);
									PrintMini(4,26,"aleatoires tel que Xn suit",1);
									PrintMini(4,34,"la loi binomiale (n,p). Zn est",1);	
									PrintMini(4,42,"une variable aleatoire",1);
									break;
									
								case 2:
									PrintMini(4,18,"On definit Zn par :",1);
									PrintMini(4,32,"Zn = ",1);
									ML_line(24,34,71,34,ML_BLACK);
									PrintMini(30,27,"Xn - n*p",1);
									racine_carre(25,36,41);
									PrintMini(31,38,"n*p*(1-p)",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Pour tout a dans ]0,1[, il",1);
									PrintMini(4,26,"existe un reel u  > 0 tel que",1);
									PrintMini(68,28,"a",1);
									PrintMini(4,34,"P(-u   Z  u ) = 1 - a",1);
									PrintMini(19,36,"a",1);
									signe_inferieur_egal(25,34);
									signe_inferieur_egal(37,34);
									PrintMini(47,36,"a",1);
									break;
								
								case 2:
									PrintMini(4,18,"On definit l'intervalle par :",1);
									PrintMini(4,36,"In=  p-u",1);
									PrintMini(37,38,"a",1);
									ML_line(20,28,20,48,ML_BLACK);
									ML_line(20,28,23,28,ML_BLACK);
									ML_line(20,48,23,48,ML_BLACK);
									ML_line(42,38,67,38,ML_BLACK);
									racine_carre(41,29,24);
									PrintMini(46,31,"p(1-p)",1);
									racine_carre(49,40,7);
									PrintMini(54,42,"n",1);
									PrintMini(70,36,",p+u",1);
									PrintMini(85,38,"a",1);
									ML_line(90,38,115,38,ML_BLACK);
									racine_carre(88,29,24);
									PrintMini(93,31,"p(1-p)",1);
									racine_carre(96,40,7);
									PrintMini(101,42,"n",1);
									ML_line(119,28,119,48,ML_BLACK);
									ML_line(119,28,116,28,ML_BLACK);
									ML_line(119,48,116,48,ML_BLACK);
									break;
									
								case 3:
									PrintMini(4,18,"In est appele intervalle de",1);
									PrintMini(4,26,"fluctuation de Xn/n au seuil",1);
									PrintMini(4,34,"1-a si n  30, np   5 et",1);
									signe_superieur_egal(36,34);
									signe_superieur_egal(70,34);
									PrintMini(4,42,"n(1-p)   5",1);
									signe_superieur_egal(30,42);
									break;
									
								case 4:
									PrintMini(4,18,"Pour a = 0,05 correspondant a",1);
									PrintMini(4,26,"un intervalle de fluctuation",1);
									PrintMini(4,34,"de 95%, u  = 1,96",1);
									PrintMini(40,36,"a",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"On considere une experience",1);
									PrintMini(4,26,"de Bernouilli, dont on veut ",1);
									PrintMini(4,34,"estimer la probabilite p du ",1);	
									PrintMini(4,42,"succes",1);
									break;
								
								case 2:
									PrintMini(4,18,"On appelle fn la frequence",1);
									PrintMini(4,26,"d'apparition du succes apres ",1);
									PrintMini(4,34,"n repetitions independantes",1);	
									break;
									
								case 3:
									PrintMini(4,18,"Si n   30, n*fn   5 et ",1);
									signe_superieur_egal(23,18);
									signe_superieur_egal(70,18);
									PrintMini(4,26,"n(1-fn)   5, p appartient",1);
									signe_superieur_egal(34,26);
									PrintMini(4,34,"a l'intervalle Ic avec un ",1);	
									PrintMini(4,42,"niveau de confiance de 95%",1);
									break;
								
								case 4:
									PrintMini(4,26,"Ic =  fn -",1);
									ML_line(24,18,24,37,ML_BLACK);
									ML_line(24,18,27,18,ML_BLACK);
									ML_line(24,37,27,37,ML_BLACK);
									ML_line(47,28,59,28,ML_BLACK);
									PrintMini(51,22,"1",1);
									racine_carre(48,30,7);
									PrintMini(53,32,"n",1);
									PrintMini(62,26,", fn +",1);
									ML_line(90,28,102,28,ML_BLACK);
									PrintMini(94,22,"1",1);
									racine_carre(91,30,7);
									PrintMini(96,32,"n",1);
									ML_line(105,18,105,37,ML_BLACK);
									ML_line(105,18,102,18,ML_BLACK);
									ML_line(105,37,102,37,ML_BLACK);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(3,choix);
				PrintXY(10,6,"Estimation : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void estimation_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(9,6,"Estim. : questions",1);
	
	question();
	
	for(i = 0 ; i < 20 ; i++)ML_line(2,47+i,47,47+i,ML_WHITE);
	
	case_question_estimation(2);
	case_question(1,2);
	
	affichage_question_estimation(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix == 1 && retour == 0)
		{
			choix = 2;
			
			case_question(1 , milieu);
			case_question(2,milieu);	
			affichage_question_estimation(2);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix == 2 && retour == 0)
		{
			choix = 1;
			
			case_question(2 , milieu);
			case_question(1 , milieu);
			affichage_question_estimation(1);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			switch(choix)
			{
				case 1:
					pages = 2;
					PrintMini(39,4,"Fluctuation",1);
					break;
				case 2:
					pages = 2;
					PrintMini(39,4,"Confiance",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <52 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour trouver un intervalle",1);
									PrintMini(4,22,"de fluctuation, il faut tout",1);
									PrintMini(4,30,"d'abord verifier que les ",1);
									PrintMini(4,38,"conditions sont favorables",1);
									PrintMini(4,46,"(n  30...)",1);
									signe_superieur_egal(13,46);
									break;
									
								case 2:
									PrintMini(4,14,"Il faut ensuite trouver le",1);
									PrintMini(4,22,"nombre u  en fonction de a",1);
									PrintMini(39,24,"a",1);
									PrintMini(4,30,"puis determiner l'intervalle",1);
									PrintMini(4,38,"a l'aide de la formule",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour trouver un intervalle",1);
									PrintMini(4,22,"de confiance, il faut tout",1);
									PrintMini(4,30,"d'abord verifier que les ",1);
									PrintMini(4,38,"conditions sont favorables",1);
									PrintMini(4,46,"(n  30...)",1);
									signe_superieur_egal(13,46);
									break;
									
								case 2:
									PrintMini(4,14,"Puis il faut se referer a la",1);
									PrintMini(4,22,"formule et determiner le",1);
									PrintMini(4,30,"le resultat",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
		
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
				PrintXY(9,6,"Estim. : questions",1);
	
				question();
			
				for(i = 0 ; i < 20 ; i++)ML_line(2,47+i,47,47+i,ML_WHITE);
			
				case_question_estimation(milieu);
				case_question(choix,milieu);
				affichage_question_estimation(choix);	
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_estimation(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	PrintMini(14,26,"Fluct.",0);
	PrintMini(8,38, "Confiance", 0);
}

void affichage_question_estimation(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"l'intervalle",0);
			PrintMini(54,38,"de",0);
			PrintMini(54,44,"fluctuation",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"l'intervalle",0);
			PrintMini(54,38,"de confiance",0);
			break;
			
	}
}