#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void integration()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	//Affichage du menu des complexes
	
	PrintXY(31,6,"Integration",1);	
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
			{
				integration_cours();
				for(i  = 20 ; i < 63 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Pour ne pas effacer l'entete
			}
			else
			{
				integration_question();
				clear();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(31,6,"Integration",1);	
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}

		ML_display_vram();	
	}	
}

void integration_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int maintien_fonction_choix_cours = 1, choix_choix_cours = 1, position_choix_cours = 1; 	//Variables pour le choix de la partie (complexes ou arguments)
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1, nombre_pages = 1; 		//Variables pour le menu des cours
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_choix_cours_integration(0);	
	affichage_integration_choix_cours(1);
						
	ML_display_vram();
	
	while(maintien_fonction_choix_cours)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction_choix_cours = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;

		if(IsKeyDown(KEY_CTRL_RIGHT) && choix_choix_cours == 1 && position_choix_cours == 1)
		{
			choix_choix_cours = 2;
			affichage_integration_choix_cours(1);
			affichage_integration_choix_cours(2);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix_choix_cours == 2 && position_choix_cours == 1)
		{
			choix_choix_cours = 1;
			affichage_integration_choix_cours(1);
			affichage_integration_choix_cours(2);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_DOWN) && position_choix_cours == 1)
		{
			position_choix_cours = 2;
			affichage_integration_choix_cours(choix_choix_cours);
			affichage_integration_choix_cours(3);
			ML_display_vram();
		
			timer();
		}

		if(IsKeyDown(KEY_CTRL_UP) && position_choix_cours == 2)
		{
			position_choix_cours = 1;
			affichage_integration_choix_cours(choix_choix_cours);
			affichage_integration_choix_cours(3);
			ML_display_vram();
		
			timer();
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && position_choix_cours == 2 && permission_quitter) ||(IsKeyDown(KEY_CTRL_EXIT) && permission_quitter))
			maintien_fonction_choix_cours = 0;
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && position_choix_cours == 1)
		{
			clear();
			
			permission_quitter = 0;
			
			nombre_pages = 5 - choix_choix_cours;	//4 pages pour la premiere partie, et 3 pour la deuxieme
			
			affichage_menu_cours(nombre_pages,1);
		
			if(choix_choix_cours == 1)
				PrintXY(6,6,"Integration : cours",1);
			else
				PrintXY(10,6,"Primitives : cours",1);
	
			while(maintien_fonction)
			{	
			
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && choix != nombre_pages  && position == 1)
				{
					choix += 1;
					choix_cours(choix,nombre_pages);
					choix_cours(choix-1,nombre_pages);
					affichage = 1;
					
					timer();
				}
				
				if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
				{
					choix -= 1;
					choix_cours(choix,nombre_pages);
					choix_cours(choix+1,nombre_pages);
					affichage = 1;
				
					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
				{
					position = 2;
					affichage = 1;
					retour_cours();
					choix_cours(choix,nombre_pages);
				}
			
				if(IsKeyDown(KEY_CTRL_UP) && position == 2)
				{
					position = 1;
					affichage = 1;
					retour_cours();
					choix_cours(choix,nombre_pages);
				}
			
				if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction = 0;
				
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
					permission_quitter = 1;
				
				if(affichage == 1)
				{
					for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
						
					if(position == 1)		// Affichage du titre de la section
					{
						if(choix_choix_cours == 1)
						{	
							switch(choix)		//Affichage nom de la partie et determination du nombre de pages
							{
								case 1:
									PrintMini(46,34,"Definition",0);
									break;
								case 2:
									PrintMini(35,34,"Valeur moyenne",0);
									break;
								case 3:
									PrintMini(43,34,"Proprietes",0);
									break;
								case 4:
									PrintMini(15,34,"Primitives et integration",0);
									break;
							}
						}
						else
						{	
							switch(choix)
							{
								case 1:
									PrintMini(46,34,"Definition",0);	
									break;
								case 2:
									PrintMini(27,34,"Fonctions usuelles",0);
									break;
								case 3:
									PrintMini(25,34,"Fonctions complexes",0);
									break;
							}
						}	
					}	
					else
						PrintMini(35,34,"Retour au menu",0);
					
					affichage = 0;
				}
	
				ML_display_vram();
			
				if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
				{
					clear();
					
					pages = 4; 		//Nombre de page predominant
					
					if(choix_choix_cours == 1)
					{	
						switch(choix)		//Affichage nom de la partie et determination du nombre de pages
						{
							case 1:
								PrintMini(46,4,"Definition",1);	
								pages = 3;
								break;
							case 2:
								PrintMini(32,4,"Valeur moyenne",1);	
								pages = 1;
								break;
							case 3:
								PrintMini(43,4,"Proprietes",1);	
								break;
							case 4:
								PrintMini(16,4,"Primitives et integration",1);	
								pages = 2;
								break;
						}
					}
					else
					{	
						switch(choix)
						{
							case 1:
								PrintMini(46,4,"Definition",1);	
								pages = 2;
								break;
							case 2:
								PrintMini(28,4,"Fonctions usuelles",1);
								break;
							case 3:
								PrintMini(25,4,"Fonctions complexes",1);	
								break;
						}
					}
				
					if((choix_choix_cours == 1 && choix == 4) || (choix_choix_cours == 2 && (choix == 2 || choix == 3)))		//Affichage bandes noires dans les parties du cours
						for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,12+118*j,i,ML_BLACK);
					else
						for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
				
					bouton_retour_cours();		//Affichage graphisme
					cours_pixel(pages);
					choix_page(1,pages);
				
					permission_quitter = 0;		//Remise a 0 des variables
					position_cours = 1;
					maintien_fonction_cours = 1;
					affichage_cours = 1;
					
					ML_display_vram();	
						
					while(maintien_fonction_cours)
					{
						
						if(IsKeyDown(KEY_CTRL_F6))
							maintien_fonction_cours = 0;
						
						if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
						{
							position_cours += 1;
							affichage_cours = 1;
					
							if(position_cours<pages+1)
								choix_page(position_cours,pages);
							else
								affichage_bouton_retour_cours();
					
							choix_page(position_cours-1,pages);
		
							timer();
						}
				
							if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
						{
							position_cours -= 1;
							affichage_cours = 1;
					
							choix_page(position_cours,pages);
					
							if(position_cours<pages)
								choix_page(position_cours+1,pages);
							else
								affichage_bouton_retour_cours();
					
							timer();
						}
			
						if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
							maintien_fonction_cours = 0;
			
						if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
			
						if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
					
						if(affichage_cours)
						{
							for(i = 14 ; i <51 ; i++)ML_line(2,i,127,i,ML_WHITE);
				
							if(choix_choix_cours == 1)
							{
								switch(choix)
								{
									case 1:		
									switch(position_cours)
										{
											case 1:
												signe_int(4,14,1);
												PrintMini(12,19,"f(x)dx est l'aire comprise",1);
												PrintMini(4,30,"entre Cf, l'axe des abscisses",1);
												PrintMini(4,38,"et les droites x = a et x = b,",1);
												PrintMini(4,46,"elle s'exprime en unite d'aire",1);
												break;
											
											case 2:
												signe_int(4,16,1);
												PrintMini(13,21,"kdx = k(b - a)",1);
												PrintMini(4,35,"Si a = b :",1);
												signe_int(46,31,1);
												PrintMini(54,36,"f(x)dx = 0",1);
												break;
											
											case 3:
												PrintMini(3,18,"Si f change de signe sur I",1);
												PrintMini(3,26,"alors l'integrale de f sur I",1);
												PrintMini(3,34,"est la difference des aires ou",1);
												PrintMini(3,42,"Cf > 0 et celle ou Cf < 0",1); 
												break;
											
											case 4:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
										
									case 2:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"On appelle valeur moyenne le",1);
												PrintMini(4,26,"reel :",1);
												PrintMini(4,37,"u =",1);
												ML_line(20,39,42,39,ML_BLACK);
												PrintMini(30,33,"1",1);
												PrintMini(21,41,"b - a",1);
												signe_int(45,32,1);
												PrintMini(53,37,"f(x)dx",1);
												break;
												
											case 2:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
									
									case 3:
										switch(position_cours)
										{
											case 1:
												signe_int(4,16,1);
												PrintMini(12,21,"[f(x)+g(x)]dx=",1);
												signe_int(62,16,1);
												PrintMini(70,21,"f(x)dx+",1);
												signe_int(95,16,1);
												PrintMini(103,21,"g(x)dx",1);
												signe_int(4,33,1);
												PrintMini(12,38,"k[f(x)]dx = k *",1);
												signe_int(72,33,1);
												PrintMini(80,38,"f(x)dx",1);
												break;
											
											case 2:
												PrintMini(4,18,"Si f(x)   0 sur [a,b] alors :",1);
												signe_superieur_egal(31,18);
												signe_int(4,26,1);
												PrintMini(12,31,"f(x)dx   0",1);
												signe_superieur_egal(36,31);
												break;
												
											case 3:
												PrintMini(4,18,"Si f(x)   g(x) sur [a,b] alors :",1);
												signe_superieur_egal(31,18);
												signe_int(4,26,1);
												PrintMini(12,31,"f(x)dx",1);
												signe_superieur_egal(36,31);
												signe_int(44,26,1);
												PrintMini(52,31,"g(x)dx",1);
												break;
												
											case 4:
												signe_int(4,16,1);
												PrintMini(12,21,"f(x)dx =",1);
												signe_int(44,16,3);
												PrintMini(52,21,"f(x)dx +",1);
												signe_int(84,16,4);
												PrintMini(92,21,"f(x)dx",1);
												signe_int(4,33,1);
												PrintMini(12,38,"f(x)dx = -",1);
												signe_int(52,33,2);
												PrintMini(60,38,"f(x)dx",1);
												break;
											case 5:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;	
										
									case 4:
										switch(position_cours)
										{
											case 1:
												PrintMini(3,18,"Si F(x) est une primitive de f(x)",1);
												PrintMini(3,26,"alors :",1);
												signe_int(4,34,1);
												PrintMini(12,39,"f(x)dx = [F(x)]  = F(b) - (Fa)",1);
												PrintMini(67,36,"b",1);
												PrintMini(66,42,"a",1);
												break;
											
											case 2:
												PrintMini(4,18,"Si D = {M(x,y) tel que a  x  b",1);
												signe_inferieur_egal(98,18);
												signe_inferieur_egal(110,18);
												PrintMini(4,26,"et g(x)  x  f(x)} alors :",1);
												signe_inferieur_egal(31,26);
												signe_inferieur_egal(43,26);
												PrintMini(4,39,"A(D) =",1);
												signe_int(28,34,1);
												PrintMini(36,39,"[f(x)-g(x)]dx",1);
												break;
												
											case 3:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;	
								}
							}
							else
							{
								switch(choix)
								{
									case 1:		
										switch(position_cours)
										{
											case 1:
												PrintMini(3,18,"Si F(x) est une primitive de f(x)",1);
												PrintMini(3,26,"alors F'(x) = f(x). f admet une",1);
												PrintMini(3,34,"infinite de primitives de la",1);
												PrintMini(3,42,"forme F + k ou k est un reel",1);
												break;
											
											case 2:
												PrintMini(4,18,"Il existe une unique primitive",1);
												PrintMini(4,26,"de f(x) telle que F(x0) = y0",1);
												break;
											
											case 3:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
										
									case 2:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"F(x) est une primitive de f(x) :",1);
												PrintMini(4,26,"f(x) = k : F(x) = kx",1);
												PrintMini(4,38,"f(x) = x   : F(x) =",1);
												PrintMini(34,36,"n",1);
												ML_line(78,40,98,40,ML_BLACK);
												PrintMini(79,34,"x",1);
												PrintMini(83,32,"n+1",1);
												PrintMini(82,42,"n+1",1);
												break;
												
											case 2:
												PrintMini(4,20,"f(x) =     : F(x) = -",1);
												ML_line(28,22,38,22,ML_BLACK);
												PrintMini(31,16,"1",1);
												PrintMini(29,25,"x",1);
												PrintMini(33,23,"n",1);
												ML_line(85,22,121,22,ML_BLACK);
												PrintMini(100,16,"1",1);
												PrintMini(86,26,"(n-1)x",1);
												PrintMini(109,24,"n-1",1);
												PrintMini(4,38,"f(x) =     : F(x) = -",1);
												ML_line(28,40,37,40,ML_BLACK);
												PrintMini(31,34,"1",1);
												PrintMini(29,44,"x",1);
												PrintMini(33,42,"2",1);
												ML_line(85,40,90,40,ML_BLACK);
												PrintMini(86,34,"1",1);
												PrintMini(86,42,"x",1);
												break;
											
											case 3:
												PrintMini(4,20,"f(x) =    : F(x) = ln(|x|)",1);
												ML_line(28,22,33,22,ML_BLACK);
												PrintMini(29,16,"1",1);
												PrintMini(29,23,"x",1);
												PrintMini(4,36,"f(x) =    : F(x) = 2",1);
												PrintMini(84,36,"x",1);
												racine_carre(79,34,6);
												ML_line(28,38,37,38,ML_BLACK);
												PrintMini(31,32,"1",1);
												racine_carre(27,40,6);
												PrintMini(32,42,"x",1);
												break;
											
											case 4:
												PrintMini(4,18,"f(x) = e   : F(x) = e",1);
												PrintMini(34,16,"x",1);
												PrintMini(83,16,"x",1);
												PrintMini(4,26,"f(x) = sin(x) : F(x) = -cos(x)",1);
												PrintMini(4,34,"f(x) = cos(x) : F(x) = sin(x)",1);
												break;
											
											case 5:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
									
									case 3:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"F(x) est une primitive de f(x),",1);
												PrintMini(4,26,"u est une fonction :",1);
												PrintMini(4,38,"f(x) = u'u   : F(x) =",1);
												PrintMini(41,36,"n",1);
												ML_line(84,40,104,40,ML_BLACK);
												PrintMini(86,34,"u",1);
												PrintMini(90,32,"n+1",1);
												PrintMini(88,42,"n+1",1);
												break;
											
											case 2:
												PrintMini(4,20,"f(x) =     : F(x) = -",1);
												ML_line(28,22,38,22,ML_BLACK);
												PrintMini(30,16,"u'",1);
												PrintMini(29,25,"u",1);
												PrintMini(33,23,"n",1);
												ML_line(85,22,121,22,ML_BLACK);
												PrintMini(100,16,"1",1);
												PrintMini(86,26,"(n-1)u",1);
												PrintMini(109,24,"n-1",1);
												PrintMini(4,38,"f(x) =     : F(x) = -",1);
												ML_line(28,40,37,40,ML_BLACK);
												PrintMini(30,34,"u'",1);
												PrintMini(29,44,"u",1);
												PrintMini(33,42,"2",1);
												ML_line(85,40,90,40,ML_BLACK);
												PrintMini(86,34,"1",1);
												PrintMini(86,42,"u",1);
												break;
											
											case 3:
												PrintMini(4,20,"f(x) =    : F(x) = ln(|u|)",1);
												ML_line(27,22,34,22,ML_BLACK);
												PrintMini(29,16,"u'",1);
												PrintMini(29,23,"u",1);
												PrintMini(4,36,"f(x) =    : F(x) = 2",1);
												PrintMini(84,36,"u",1);
												racine_carre(79,34,6);
												ML_line(28,38,37,38,ML_BLACK);
												PrintMini(31,32,"u'",1);
												racine_carre(27,40,6);
												PrintMini(32,42,"u",1);
												break;
											
											case 4:
												PrintMini(4,18,"f(x) = u'*e   : F(x) = e",1);
												PrintMini(47,16,"u",1);
												PrintMini(96,16,"u",1);
												PrintMini(4,26,"f(x) = u'*sin(u) : F(x) = -cos(u)",1);
												PrintMini(4,34,"f(x) = u'*cos(u) : F(x) = sin(u)",1);
												break;
												
											case 5:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
								}
								
							}	
		
							affichage_cours = 0;
						}
					
						ML_display_vram();
					}
				
					clear();
					
					if(IsKeyUp(KEY_CTRL_F6))
					{
						affichage_menu_cours(nombre_pages,choix);
						
						if(choix_choix_cours == 1)
							PrintXY(6,6,"Integration : cours",1);
						else
							PrintXY(10,6,"Primitives : cours",1);
					}
					
					affichage = 1;
					
					permission_quitter  = 0;
				}
			}
			
			clear();
			
			affichage_menu_choix_cours_integration(1);
			affichage_integration_choix_cours(choix_choix_cours);
	
			ML_display_vram();
			
			permission_quitter = 0;				//Remise a 0 des variables
			maintien_fonction_choix_cours = 1;
			maintien_fonction_cours = 1;
			maintien_fonction = 1;
			affichage = 1;
			position = 1;
			position_cours = 1;
			affichage_cours = 1;
			choix = 1;
		}
	}
}

void integration_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(9,6,"Integ. : questions",1);
	
	question();
	
	for(i = 0 ; i < 20 ; i++)ML_line(2,47+i,47,47+i,ML_WHITE);
	
	case_question_integration(2);
	case_question(1,2);
	
	affichage_question_integration(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix == 1 && retour == 0)
		{
			choix = 2;
			
			case_question(1 , milieu);
			case_question(2,milieu);	
			affichage_question_integration(2);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix == 2 && retour == 0)
		{
			choix = 1;
			
			case_question(2 , milieu);
			case_question(1 , milieu);
			affichage_question_integration(1);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			switch(choix)
			{
				case 1:
					pages = 2;
					PrintMini(39,4,"Interpretation",1);
					break;
				case 2:
					pages = 3;
					PrintMini(39,4,"Calcul integrale",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <51 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									signe_int(4,14,1);
									PrintMini(12,19,"f(x)dx est l'aire comprise",1);
									PrintMini(4,30,"entre Cf, l'axe des abscisses",1);
									PrintMini(4,38,"et les droites x = a et x = b,",1);
									PrintMini(4,46,"elle s'exprime en unite d'aire",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple :",1);
									signe_int(4,22,5);
									PrintMini(12,27,"f(x)dx est l'aire comprise",1);
									PrintMini(4,38,"entre Cf, l'axe des abscisses",1);
									PrintMini(4,46,"et les droites x = 0 et x = 1,",1);
									break;
				
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour calculer l'integrale",1);
									PrintMini(4,22,"d'une fonction, il faut trouver",1);
									PrintMini(4,30,"une primitive de la fonction",1);
									PrintMini(4,38,"puis utiliser la formule",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple :",1);
									PrintMini(4,27,"Calculer",1);
									signe_int(40,22,5);
									PrintMini(48,27,"(5x + 7)dx",1);
									PrintMini(4,40,"On pose f(x) = 5x + 7",1);
									break;
								
								case 3:
									PrintMini(4,14,"Une primitive de la fonction f",1);
									PrintMini(4,22,"est : F(x) = (5/2)x  + 7x",1);
									PrintMini(75,20,"2",1);
									PrintMini(4,34,"Ainsi",1);
									signe_int(28,30,5);
									PrintMini(36,34,"(5x + 7)dx = [F(x)]",1);
									PrintMini(106,30,"1",1);
									PrintMini(106,38,"0",1);
									PrintMini(78,46,"= 19/2",1);
									break;
								
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
		
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
				PrintXY(9,6,"Integ. : questions",1);
	
				question();
			
				for(i = 0 ; i < 20 ; i++)ML_line(2,47+i,47,47+i,ML_WHITE);
			
				case_question_integration(milieu);
				case_question(choix,milieu);
				affichage_question_integration(choix);	
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_integration(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	PrintMini(8,26,"Graphique",0);
	PrintMini(14,38, "Calcul", 0);
}

void affichage_question_integration(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Faire une",0);
			PrintMini(54,32,"interpreta-",0);
			PrintMini(54,38,"tion",0);
			PrintMini(54,44,"graphique",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Calcul d'une",0);
			PrintMini(54,32,"integrale de",0);
			PrintMini(54,38,"base",0);
			break;
			
	}
}