#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void limites()		//chapitre sur les limites
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	//Affichage du menu des suites
	
	PrintXY(43,6,"Limites",1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				limites_cours();
	
			if(choix == 2)
				limites_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(43,6,"Limites",1);
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	

	}

	
}

void limites_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(7,1);
	
	PrintXY(18,6,"Limites : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 7  && position == 1)
		{
			choix += 1;
			choix_cours(choix,7);
			choix_cours(choix-1,7);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,7);
			choix_cours(choix+1,7);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,7);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,7);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(46,34,"Definition",0);
						break;
					case 2:
						PrintMini(20,34,"Formes indeterminees",0);
						break;
					case 3:
						PrintMini(34,34,"Limites simples",0);
						break;
					case 4:
						PrintMini(16,34,"Theoreme des gendarmes",0);
						break;
					case 5:
						PrintMini(16,34,"Theoreme de comparaison",0);
						break;
					case 6:
						PrintMini(46,34,"Continuite",0);
						break;
					case 7:
						PrintMini(22,34,"Valeurs intermediaires",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 2;		//Nombre de pages predominant
			
			switch(choix)		//Affichage nom de la partie et determination du nombre de pages
			{
				case 1: 
					pages = 3;
					PrintMini(46,4,"Definition",1);
					break;
				case 2:
					PrintMini(20,4,"Formes indeterminees",1);	
					break;
				case 3:
					pages = 5;
					PrintMini(34,4,"Limites simples",1);	
					break;
				case 4:
					PrintMini(16,4,"Theoreme des gendarmes",1);	
					break;
				case 5:
					PrintMini(16,4,"Theoreme de comparaison",1);	
					break;
				case 6:
					PrintMini(46,4,"Continuite",1);	
					break;
				case 7:
					pages = 3;
					PrintMini(20,4,"Valeurs intermediaires",1);
					break;
			}
			
			if(choix == 2 || choix == 4 || choix == 5 || choix == 7)								//Affichage des deux bandes noires
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,11+116*j,i,ML_BLACK);
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);	
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 16 ; i <51 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"La limite d'une fonction en un",1);
									PrintMini(4,26,"point est la valeur dont elle ",1);
									PrintMini(4,34,"s'approche lorsque la variable",1);
									PrintMini(4,42,"tend vers ce point",1);
									break;
									
								case 2:
									PrintMini(4,18,"Cette valeur et ce point",1);
									PrintMini(4,26,"peuvent etre un reel ou",1);
									PrintMini(4,34,"l'infini",1);
									break;
									
								case 3:
									PrintMini(4,18,"Exemple : La limite de f(x)",1);
									PrintMini(4,26,"lorsque x tend vers 0 est l :",1);
									affichage_limite(4,34,0,0);
									PrintMini(20,34,"f(x) = l",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Lors du calcul d'une limite",1);
									PrintMini(4,26,"on peut rencontrer des forme",1);
									PrintMini(4,34,"indeterminees : 0 *   , 0 / 0,",1);
									infini(83,35);
									PrintMini(4,42,"   /    , -   +",1);
									infini(4,43);
									infini(20,43);
									infini(48,43);
									infini(64,43);
									break;
								
								case 2:
									PrintMini(4,18,"Les F.I empechent le calcul",1);
									PrintMini(4,26,"d'une limite, il faut donc",1);
									PrintMini(4,34,"factoriser ou multiplier par",1);
									PrintMini(4,42,"le conjugue (voir questions)",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									affichage_limite(4,18,100,0);
									affichage_limite(4,34,-100,0);
									PrintMini(20,18,"x  = +",1);
									PrintMini(24,16,"2",1);
									PrintMini(20,34,"x  = +",1);
									PrintMini(24,32,"2",1);
									infini(45,19);
									infini(45,35);
									break;
								
								case 2:
									affichage_limite(4,18,100,0);
									affichage_limite(4,34,-100,0);
									PrintMini(20,18,"x  = +",1);
									PrintMini(24,16,"3",1);
									PrintMini(20,34,"x  = -",1);
									PrintMini(24,32,"3",1);
									infini(45,19);
									infini(45,35);
									break;
									
								case 3:
									affichage_limite(4,18,100,0);
									affichage_limite(4,34,0,1);
									PrintMini(20,18,"(1/x) = 0",1);
									PrintMini(54,16,"+",1);
									PrintMini(20,34,"(1/x) = +",1);
									infini(55,35);
									break;
							
								case 4:
									affichage_limite(4,18,-100,0);
									affichage_limite(4,34,0,-1);
									PrintMini(20,18,"(1/x) = 0",1);
									PrintMini(54,16,"-",1);
									PrintMini(20,34,"(1/x) = -",1);
									infini(55,35);
									break;
								
								case 5:
									affichage_limite(4,18,100,0);
									racine_carre(20,16,6);
									PrintMini(25,18,"x = +",1);
									infini(47,19);
									break;
									
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Si pour tout x   p on a",1);
									signe_superieur_egal(63,18);
									PrintMini(4,26,"g(x)   f(x)   h(x) , et",1);
									signe_inferieur_egal(21,26);
									signe_inferieur_egal(48,26);
									affichage_limite(4,34,20,0);
									PrintMini(20,34,"g(x) =",1);
									affichage_limite(45,34,20,0);
									PrintMini(61,34,"h(x) = l",1);
									break;
								
								case 2:
									PrintMini(4,18,"Alors",1);
									affichage_limite(28,18,20,0);
									PrintMini(44,18,"f(x) = l",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Si     g(x) =        f(x)   g(x)",1);
									PrintMini(73,18,"et",1);
									PrintMini(54,18,"+",1);	
									affichage_limite(14,18,20,0);
									infini(59,19);	
									signe_superieur_egal(101,18);
									PrintMini(4,34,"alors :     f(x) = +",1);
									infini(84,35);
									affichage_limite(36,34,20,0);
									break;
								
								case 2:
									PrintMini(4,18,"Si     f(x) =        f(x)   g(x)",1);
									PrintMini(73,18,"et",1);
									PrintMini(54,18,"-",1);	
									affichage_limite(14,18,20,0);
									infini(59,19);	
									signe_superieur_egal(101,18);
									PrintMini(4,34,"alors :     g(x) = -",1);
									infini(84,35);
									affichage_limite(36,34,20,0);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 6:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"f est continue en a si :",1);
									affichage_limite(4,26,20,0);
									PrintMini(20,26,"f(x) = f(a)",1);	
									break;
								
								case 2:
									PrintMini(4,18,"f est continue sur I si",1);
									PrintMini(4,26,"f est continue en tout reel a",1);
									PrintMini(4,34,"de I",1);	
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 7:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Si f est continue sur I et a",1);
									PrintMini(4,26,"valeur dans [a,b] alors pour",1);
									PrintMini(4,34,"tout k dans [a,b] f(x) = k",1);
									PrintMini(4,42,"admet au moins une solution",1);
									break;
								
								case 2:
									PrintMini(4,18,"Si f est continue et strict.",1);
									PrintMini(4,26,"monotone sur I et a valeur",1);
									PrintMini(4,34,"dans [a,b] alors pour tout k",1);
									PrintMini(4,42,"dans [a,b] :",1);
									 break;
									
								case 3:
									PrintMini(4,18,"il existe un unique reel t",1);
									PrintMini(4,26,"tel que f(t) = k",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(7,choix);
				PrintXY(18,6,"Limites : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void limites_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0, fleche = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour, fleche : si c'est egal a 1 : regarde s'il faut afficher ou non une fleche
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(8,6,"Limites : questions",1);
	
	question();
	
	case_question_limites(2);
	case_question(1,2);

	fleche_question(milieu,4);
	
	affichage_question_limites(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 5 && retour == 0)
		{
			choix ++;
			
			if(choix > (milieu + 1))
			{	
				milieu ++;
				fleche = 1;		
				case_question_limites(milieu);
				
			}
			else
				case_question(choix - 1 , milieu);
			
			case_question(choix,milieu);	
			affichage_question_limites(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			if(choix < (milieu - 1))
			{	
				milieu --;
				fleche = 1;
				case_question_limites(milieu);
				case_question(choix,milieu);
			}
			else
			{
				case_question(choix + 1 , milieu);
				case_question(choix , milieu);
			}
	
			affichage_question_limites(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(fleche)	//Affichage des fleches pour que l'utilisateur sache s'il y a des choix plus bas ou plus haut
		{
			fleche_question(milieu,4);
			fleche = 0;	
		}

		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			pages = 4;		//Pour les questions 2 a 5	
			
			switch(choix)
			{
				case 1:
					pages = 2;
					PrintMini(39,4,"Limites simples",1);
					break;
				case 2:
					pages = 2;
					PrintMini(39,4,"Limites en factorisant",1);
					break;
				case 3:
					pages = 3;
					PrintMini(39,4,"Limites et conjugue",1);
					break;
				case 4:
					PrintMini(39,4,"Continuite",1);
					break;
				case 5:
					PrintMini(39,4,"Valeurs intermediaires",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <53 ; i++)ML_line(2,i,125,i,ML_WHITE);
					ML_line(2,53,100,53,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Une limite est simple si la",1);
									PrintMini(4,22,"fonction ne presente pas de",1);
									PrintMini(4,30,"formes indeterminees (F.I)",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : f(x) = 3x + 5",1);
									affichage_limite(4,22,100,0);
									PrintMini(20,22,"f(x) = +",1);
									infini(50,23);
									affichage_limite(4,35,0,0);
									PrintMini(20,35,"f(x) = 5",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Si la fonction presente des",1);
									PrintMini(4,22,"F.I, il faut essayer de",1);
									PrintMini(4,30,"factoriser par la variable",1);
									PrintMini(4,38,"avec la puissance la plus",1);
									PrintMini(4,46,"haute",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : f(x) = (3x +5)/(x +2)",1);
									PrintMini(82,13,"2",1);
									PrintMini(108,13,"2",1);
									PrintMini(4,24,"En factorisant par x  on a",1);
									PrintMini(86,22,"2",1);
									PrintMini(4,33,"f(x) = [3+(5/x )]/(1+(2/x )]",1);
									PrintMini(56,31,"2",1);
									PrintMini(96,31,"2",1);
									PrintMini(4,42,"D'ou",1);
									affichage_limite(22,42,100,0);
									PrintMini(38,42,"f(x) = 3",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Si la fonction presente des",1);
									PrintMini(4,22,"F.I et qu'elle est constituee",1);
									PrintMini(4,30,"de racine carree, il faut",1);
									PrintMini(4,38,"multiplier par le conjugue",1);
									PrintMini(4,46,"(puis factoriser si necessaire)",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : f(x) =",1);
									racine_carre(69,13,6);
									PrintMini(74,15,"x - x",1);
									PrintMini(4,29,"En multipliant par         :",1);
									ML_line(80,31,106,31,ML_BLACK);
									racine_carre(81,22,6);
									PrintMini(86,24,"x + x",1);
									racine_carre(81,33,6);
									PrintMini(86,35,"x + x",1);
									PrintMini(4,42,"f(x) =",1);
									ML_line(28,44,54,44,ML_BLACK);
									PrintMini(30,38,"x - x",1);
									PrintMini(51,36,"2",1);
									racine_carre(29,46,6);
									PrintMini(34,48,"x + x",1);
									break;
								
								case 3:
									PrintMini(4,14,"Puis en factorisant par x on a",1);
									PrintMini(4,26,"f(x) =",1);
									ML_line(28,28,54,28,ML_BLACK);
									PrintMini(31,22,"1 - x",1);
									PrintMini(32,30,"1",1);
									ML_line(29,36,38,36,ML_BLACK);
									racine_carre(28,38,6);
									PrintMini(33,40,"x",1);
									PrintMini(42,34,"+ 1",1);
									PrintMini(65,26,"Il n'y a plus",1);
									PrintMini(65,34,"de F.I en +",1);
									infini(111,35);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 4:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour trouver l'equation d'une",1);
									PrintMini(4,22,"droite en faisant en sorte que",1);
									PrintMini(4,30,"la fonction soit continue, il",1);
									PrintMini(4,38,"faut utiliser la formule",1);
									PrintMini(4,46,"enoncee dans \"continuite\"",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : la fonction f definie",1);
									PrintMini(4,22,"sur |R par",1);
									PrintMini(4,38,"f(x) =  mx + p si 0  x  2",1);
									signe_inferieur_egal(80,38);
									signe_inferieur_egal(92,38);
									PrintMini(34,30,"x - 1 si x < 0",1);
									PrintMini(34,46,"-(1/2)x + 8 si x > 2",1);
									ML_line(31,30,31,52,ML_BLACK);
									break;
								
								case 3:
									PrintMini(4,14,"Determiner m et p pour que f soit",1);
									PrintMini(4,22,"soit continue en 0 et 2 :",1);
									affichage_limite(4,29,0,0);
									PrintMini(20,29,"x - 1 = -1",1);
									affichage_limite(22,42,0,0);
									PrintMini(4,42,"D'ou",1);
									PrintMini(38,42,"mx + p = -1 : p = -1",1);
									break;
								
								case 4:
									affichage_limite(4,14,2,0);
									PrintMini(20,14,"-(1/2)x + 8 = 7",1);
									affichage_limite(22,27,2,0);
									PrintMini(4,27,"D'ou",1);
									PrintMini(38,27,"mx - 1 = 7 : m = 4",1);
									PrintMini(4,43,"Ainsi f(x)=4x-1 pour 0  x  2",1);
									signe_inferieur_egal(90,43);
									signe_inferieur_egal(102,43);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 5:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour prouver qu'une l'equation",1);
									PrintMini(4,22,"admet une ou plusieurs",1);
									PrintMini(4,30,"solutions, il faut utiliser le",1);
									PrintMini(4,38,"theoreme des valeurs",1);
									PrintMini(4,46,"intermediaires",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : f(x)=-2x +3x +12x",1);
									PrintMini(75,13,"3   2",1);
									PrintMini(4,23,"Montrer que f(x) = 8 admet 3",1);
									PrintMini(4,31,"solutions sur |R :",1);
									PrintMini(4,39,"f'(x) = -6x  + 6x + 12",1);
									PrintMini(46,37,"2",1);
									PrintMini(4,47,"f'(x) = 0 pour x=-1 ou x=2",1);
									break;
								
								case 3:
									PrintMini(4,14,"f est strictement decroissante",1);
									PrintMini(4,20,"sur ]-   ,-1] et a valeur dans",1);
									PrintMini(4,26,"[-7,+   [ (contenant 8)",1);
									infini(29,21);
									infini(23,27);
									PrintMini(4,32,"f est strictement croissante",1);
									PrintMini(4,38,"sur ]-1,2] et a valeur dans",1);
									PrintMini(4,44,"[-7,20] (contenant 8)",1);
									break;
								
								case 4:
									PrintMini(4,14,"f est strictement decroissante",1);
									PrintMini(4,20,"sur [2,+   [ et a valeur dans",1);
									PrintMini(4,26,"]-   ,20] (contenant 8)",1);
									infini(37,21);
									infini(12,27);
									PrintMini(4,32,"8 est dans ces 3 intervalles",1);
									PrintMini(4,38,"Donc l'equation f(x) = 8",1);
									PrintMini(4,44,"admet 3 solutions sur |R",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(8,6,"Limites : questions",1);
		
				question();
				
				case_question_limites(milieu);
				case_question(choix,milieu);
				affichage_question_limites(choix);	
				fleche_question(milieu,4);
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_limites(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	if(milieu == 2)PrintMini(11,26,"Limite 1",0);
	if(milieu > 1 && milieu < 4)PrintMini(11,62 - 12*milieu, "Limite 2", 0);
	if(milieu > 1 && milieu < 5)PrintMini(11,74 - 12*milieu, "Limite 3", 0);
	if(milieu > 2 && milieu < 6)PrintMini(7,86 - 12*milieu, "Continuite", 0);
	if(milieu > 3 && milieu < 7)PrintMini(14,98 - 12*milieu, "Inter.", 0);
}

void affichage_question_limites(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Calculer une",0);
			PrintMini(54,32,"limite simple",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Calculer une",0);
			PrintMini(54,32,"limite en",0);
			PrintMini(54,38,"factorisant",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Calculer une",0);
			PrintMini(54,32,"limite en",0);
			PrintMini(54,38,"multipliant",0);
			PrintMini(54,44,"par le",0);
			PrintMini(54,50,"conjugue",0);
			break;
	
		case 4 :
			PrintMini(54,26,"Trouver la",0);
			PrintMini(54,32,"droite",0);
			PrintMini(54,38,"rendant une",0);
			PrintMini(54,44,"fonction",0);
			PrintMini(54,50,"continue",1);
			break;
			
		case 5 :
			PrintMini(54,26,"Utiliser le",0);
			PrintMini(54,32,"theoreme",0);
			PrintMini(54,38,"des valeurs",0);
			PrintMini(54,44,"inter.",1);
			break;
	}
}