#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void loi_proba()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	
	
	PrintXY(10,6,"Loi de probabilite",1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				loi_proba_cours();
	
			if(choix == 2)
				loi_proba_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(10,6,"Loi de probabilite",1);
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	
	}
}

void loi_proba_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(5,1);
	
	PrintXY(9,6,"Loi proba. : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 5  && position == 1)
		{
			choix += 1;
			choix_cours(choix,5);
			choix_cours(choix-1,5);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,5);
			choix_cours(choix+1,5);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,5);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,5);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(41,34,"Generalites",0);
						break;
					case 2:
						PrintMini(39,34,"Loi uniforme",0);
						break;
					case 3:
						PrintMini(30,34,"Loi exponentielle",0);
						break;
					case 4:
						PrintMini(9,34,"Loi normale centree reduite",0);
						break;
					case 5:
						PrintMini(22,34,"Loi normale generale",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 5;		//Nombre de pages predominant
			
			switch(choix)
			{
				case 1:
					pages = 3;
					PrintMini(41,4,"Generalites",0);
					break;
				case 2:
					pages = 4;
					PrintMini(39,4,"Loi uniforme",0);
					break;
				case 3:
					PrintMini(30,4,"Loi exponentielle",0);
					break;
				case 4:
					PrintMini(9,4,"Loi normale centree reduite",0);
					break;
				case 5:
					pages = 2;
					PrintMini(22,4,"Loi normale generale",0);
					break;
			}
			
			if(choix == 4)		//Affichage des deux bandes noires
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+123*j,i,6+123*j,i,ML_BLACK);
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
				
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 14 ; i <52 ; i++)ML_line(2,i,127,i,ML_WHITE);
					
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,16,"On appelle densite de proba.",1);
									PrintMini(4,24,"sur I, toute fonction f",1);
									PrintMini(4,32,"continue et positive sur I",1);
									PrintMini(4,42,"verifiant",1);
									signe_int(41,38,6);
									PrintMini(49,42,"f(x)dx = 1",1);
									break;
								
								case 2:
									PrintMini(4,16,"Une variable aleatoire X admet",1);
									PrintMini(4,24,"f comme densite de proba. sur",1);
									PrintMini(4,32,"I si pour tout J dans I :",1);
									PrintMini(4,42,"P(x",1);
									appartient(15,42);
									PrintMini(20,42,"J) =",1);
									signe_int(39,38,7);
									PrintMini(47,42,"f(x)dx",1);
									break;
									
								case 3:
									PrintMini(4,16,"L'esperance d'une variable",1);
									PrintMini(4,24,"aleatoire X de densite f sur I",1);
									PrintMini(4,32,"est :",1);
									PrintMini(4,42,"E(x) =",1);
									signe_int(28,38,6);
									PrintMini(36,42,"xf(x)dx",1);
									break;
								
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Une variable aleatoire X suit",1);
									PrintMini(4,26,"la loi uniforme sur I si la",1);
									PrintMini(4,34,"fonction densite de proba.",1);
									PrintMini(4,42,"est constante sur I",1);
									break;
								
								case 2:
									PrintMini(4,18,"Soit X suivant la loi uniforme sur",1);
									PrintMini(4,26,"sur [a,b], la fonction densite",1);
									PrintMini(4,34,"est definie par :",1);
									PrintMini(4,42,"f(x) = 1/(b-a)",1);
									break;
									
								case 3:
									PrintMini(4,18,"Soit X suivant la loi uniforme sur",1);
									PrintMini(4,26,"sur [a,b], alors pour tout |R",1);
									PrintMini(4,34,"c et d tels que a  c  d  b",1);
									signe_inferieur_egal(73,34);
									signe_inferieur_egal(86,34);
									signe_inferieur_egal(98,34);
									PrintMini(4,42,"P(X",1);
									appartient(15,42);
									PrintMini(20,42,"[c,d]) = (d-c)/(b-a)",1);
									break;
									
								case 4:
									PrintMini(4,18,"Si X suit la loi uniforme",1);
									PrintMini(4,26,"alors son esperance est :",1);
									PrintMini(4,34,"E(X) = (a+b)/2",1);
									break;
										
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Une variable aleatoire X suit",1);
									PrintMini(4,26,"la loi exponentielle de param.",1);
									lambda_cours(4,34);
									PrintMini(12,34,"si la densite de proba. f de",1);
									PrintMini(4,43,"X est : f(x) =  e",1);
									lambda_cours(58,43);
									PrintMini(70,40,"-",1);
									lambda_cours(73,40);
									PrintMini(80,40,"t",1);
									break;
									
								case 2:
									PrintMini(4,16,"Si X suit la loi exponentielle",1);
									PrintMini(4,24,"de parametre",1);
									lambda_cours(58,24);
									PrintMini(65,24,",et si a, b   |R",1);
									appartient(108,24);
									PrintMini(123,22,"+",1);
									PrintMini(4,32,"avec a   b, alors :",1);
									signe_inferieur_egal(32,32);
									PrintMini(4,42,"P(X",1);
									appartient(15,42);
									PrintMini(20,42,"[a,b]) =",1);
									signe_int(50,38,1); 
									PrintMini(66,42,"e",1);
									lambda_cours(59,42);
									PrintMini(71,39,"-",1);
									lambda_cours(74,39);
									PrintMini(81,39,"t",1);
									PrintMini(86,42,"dt",1);
									break;
								
								case 3:
									PrintMini(4,18,"P(a  X  b) = e     - e",1);
									signe_inferieur_egal(16,18);
									signe_inferieur_egal(28,18);
									PrintMini(59,16,"-",1);
									lambda_cours(62,16);
									PrintMini(69,16,"a",1);
									PrintMini(91,16,"-",1);
									lambda_cours(94,16);
									PrintMini(101,16,"b",1);
									PrintMini(4,26,"P(X = a) = 0",1);
									PrintMini(4,34,"P(X  a) = e",1);
									signe_superieur_egal(17,34);
									PrintMini(47,32,"-",1);
									lambda_cours(51,32);
									PrintMini(58,32,"a",1);
									break;
								
								case 4:
									PrintMini(4,18,"La loi de duree de vie sans",1);
									PrintMini(4,26,"vieillissement :",1);
									PrintMini(4,34,"P",1);
									PrintMini(34,34,"(X > t + h) = p(X > h)",1);
									PrintMini(8,36,"(X > t)",1);
									break;
								
								case 5:
									PrintMini(4,18,"Si X suit la loi exponentielle",1);
									PrintMini(4,26,"de parametre",1);
									lambda_cours(58,26);
									PrintMini(65,26,", alors son",1);
									PrintMini(4,34,"esperance est :",1);
									PrintMini(4,42,"E(X) = 1/",1);
									lambda_cours(38,42);
									break;
								
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Une variable aleatoire X suit",1);
									PrintMini(4,26,"la loi normale centree reduite",1);
									PrintMini(4,34,"notee N(0,1) si elle admet",1);
									PrintMini(4,42,"pour densite : ",1);
									break;
								
								case 2:
									PrintMini(4,24,"f(x) =",1);
									ML_line(28,26,44,26,ML_BLACK);
									PrintMini(35,20,"1",1);
									racine_carre(28,28,12);
									PrintMini(33,30,"2",1);
									pi(37,30);
									PrintMini(46,24,"e",1);
									PrintMini(50,20,"-",1);
									ML_line(54,22,61,22,ML_BLACK);
									PrintMini(54,16,"x",1);
									PrintMini(58,14,"2",1);
									PrintMini(56,24,"2",1);
									break;
									
								case 3:
									PrintMini(4,16,"Si Z suit la loi normale",1);
									PrintMini(4,24,"centree reduite, alors pour",1);
									PrintMini(4,32,"tout |R a et b tels que a  b",1);
									signe_inferieur_egal(103,32);
									PrintMini(4,42,"P(Z",1);
									appartient(15,42);
									PrintMini(20,42,"[a,b]) =",1);
									signe_int(50,38,1); 
									PrintMini(58,42,"f(x)dx",1);
									break;
									
								case 4:
									PrintMini(4,18,"Pour tout a dans ]0,1[, il",1);
									PrintMini(4,26,"existe un reel u  > 0 tel que",1);
									PrintMini(68,28,"a",1);
									PrintMini(4,34,"P(-u   Z  u ) = 1 - a",1);
									PrintMini(19,36,"a",1);
									signe_inferieur_egal(25,34);
									signe_inferieur_egal(37,34);
									PrintMini(47,36,"a",1);
									break;
									
								case 5:
									PrintMini(4,18,"Si X suit la loi normale",1);
									PrintMini(4,26,"centree reduite, alors :",1);
									PrintMini(4,34,"E(X) = 0 et V(X) = 1",1);
									break;
							
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Une variable aleatoire X suit",1);
									PrintMini(4,26,"la loi normale N(a,b ) si la",1);
									PrintMini(86,24,"2",1);
									PrintMini(4,34,"variable aleatoire (X-a)/b",1);
									PrintMini(4,42,"suit la loi normale N(0,1)",1);
									break;
								
								case 2:
									PrintMini(4,18,"Par consequent :",1);
									PrintMini(4,26,"P(X  a) = P(x  a)",1);
									signe_inferieur_egal(17,26);
									signe_superieur_egal(55,26);
									PrintMini(4,34,"E(X) = a et V(x) = b",1);
									PrintMini(80,32,"2",1);
									PrintMini(4,42,"son ecart type est egal a b",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(5,choix);
				PrintXY(9,6,"Loi proba. : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void loi_proba_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(9,6,"Loi proba. : quest.",1);
	
	question();
	
	case_question_loi_proba(2);
	case_question(1,2);
	
	affichage_question_loi_proba(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 3 && retour == 0)
		{
			choix ++;
			
			case_question(choix - 1 , milieu);
			case_question(choix,milieu);	
			affichage_question_loi_proba(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			case_question(choix + 1 , milieu);
			case_question(choix , milieu);
			affichage_question_loi_proba(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			switch(choix)
			{
				case 1:
					pages = 3;
					PrintMini(39,4,"Densite de probabilite",1);
					break;
				case 2:
					pages = 3;
					PrintMini(39,4,"Calcul de lambda",1);
					break;
				case 3:
					pages = 2;
					PrintMini(39,4,"Calcul de normes",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <52 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"On appelle densite de proba.",1);
									PrintMini(4,22,"sur I, toute fonction f",1);
									PrintMini(4,30,"continue et positive sur I",1);
									PrintMini(4,40,"verifiant",1);
									signe_int(41,36,6);
									PrintMini(49,40,"f(x)dx = 1",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : f est definie",1);
									PrintMini(4,22,"sur [1,e] par f(x) = 1/x",1);
									PrintMini(4,30,"une primitive de f est :",1);
									PrintMini(4,38,"F(x) = ln(x)",1);
									break;
								
								case 3:
									PrintMini(4,18,"Ainsi",1);
									signe_int(28,14,8);
									PrintMini(37,18,"(1/x)dx = ln(e)-ln(1)",1);
									PrintMini(67,26,"= 1",1);
									PrintMini(4,34,"Donc f est une densite de",1);
									PrintMini(4,42,"probabilite sur [1,e]",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Une variable aleatoire X suit",1);
									PrintMini(4,22,"la loi exponentielle de param.",1);
									lambda_cours(4,30);
									PrintMini(12,30,"si la densite de proba. f de",1);
									PrintMini(4,39,"X est : f(x) =  e",1);
									lambda_cours(58,39);
									PrintMini(70,36,"-",1);
									lambda_cours(73,36);
									PrintMini(80,36,"t",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : X suit une loi",1);
									PrintMini(4,22,"exponentielle. Calculons",1);
									lambda_cours(4,30);
									PrintMini(12,30,"sachant que P(X  2) = 0,15",1);
									signe_inferieur_egal(73,30);
									PrintMini(4,38,"P(X  2) = P(0  X  2)",1);
									signe_inferieur_egal(16,38);
									signe_inferieur_egal(54,38);
									signe_inferieur_egal(67,38);
									PrintMini(34,47,"= e  - e",1);
									PrintMini(47,45,"0",1);
									PrintMini(67,45,"-2",1);
									lambda_cours(74,45);
									break;
								
								case 3:
									PrintMini(4,14,"Par consequent :",1);
									PrintMini(4,23,"1 - e    = 0,15",1);
									PrintMini(24,21,"-2",1);
									lambda_cours(32,21);
									equivaut(4,31);
									lambda_cours(18,31);
									PrintMini(28,31,"= -[ln(0,85)]/2",1);
									break;
								
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,15,"Si X suit la loi N(a,b ) :",1);
									PrintMini(86,13,"2",1);
									PrintMini(4,22,"P(u  X  v) = NormCD(u,v,b,a)",1);
									signe_inferieur_egal(16,22);
									signe_inferieur_egal(29,22);
									PrintMini(4,30,"Pour le trouver : [OPTN],",1);
									PrintMini(4,38,"[STAT], [DIST], [NORM], [NCD]",1);
									break;
									
								case 2:
									PrintMini(4,14,"Si P(X  u) = v, alors :",1);
									signe_inferieur_egal(26,14);
									PrintMini(4,22,"u = InvNormCD(v,b,a)",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(9,6,"Loi proba. : quest.",1);
		
				question();
				
				case_question_loi_proba(milieu);
				case_question(choix,milieu);
				affichage_question_loi_proba(choix);	
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_loi_proba(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	PrintMini(13,26, "Densite", 0);
	PrintMini(13,38,"Lambda",0);
	PrintMini(12,50, "Normes", 0);
}

void affichage_question_loi_proba(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Montrer ",0);
			PrintMini(54,32,"qu'une",1);
			PrintMini(54,38,"fonction est",0);
			PrintMini(54,44,"une densite",1);
			PrintMini(54,50,"de proba.",1);
			break;
		
		case 2 :
			PrintMini(54,26,"Calculer la",0);
			PrintMini(54,32,"valeur de",0);
			lambda_cours(94,32);
			PrintMini(54,38,"(loi expo.)",1);
			break;
			
		case 3 :
			PrintMini(54,26,"Calcul et",0);
			PrintMini(54,32,"utilisation",0);
			PrintMini(54,38,"de la casio",0);
			break;
	}
	
}