#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "cours.h"

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int i = 0, j = 0, permission_quitter = 1, maintien_fonction = 1, choix = 1, max = 13, droite = 0 , gauche = 0;	
	
	clear();
	
	aff_menu_principal(choix,max);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && IsKeyUp(KEY_CTRL_LEFT) && choix < max)
		{	
			choix+=1;
			
			if(droite == 1 && choix == max-1)
				chgt_fleche(2);
			
			if(droite == 0 && choix < max-1)
				chgt_fleche(2);
				
			if(choix < max-1)droite = 1;
			
			if(choix == 2)affichage_carre_menu(1);
			
			if(choix == 3)affichage_fleche(1);	
			
			if(choix == max)affichage_carre_menu(2);
			
			if(choix == max-1)affichage_fleche(2);
			
			nom_chapitre(choix);
			
			ML_display_vram();
			
			timer();
		}
		
		if(IsKeyUp(KEY_CTRL_RIGHT) && droite == 1)
		{
			droite = 0;
			if(choix < max-1)chgt_fleche(2);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && IsKeyUp(KEY_CTRL_RIGHT) && choix > 1)
		{	
			choix-=1;
			
			if(gauche == 1 && choix == 2)
				chgt_fleche(1);
			
			if(gauche == 0 && choix > 2)
				chgt_fleche(1);
				
			if(choix > 2)gauche = 1;
			
			if(choix == 1)affichage_carre_menu(1);
			
			if(choix == 2)affichage_fleche(1);
			
			if(choix == max-1)affichage_carre_menu(2);
			
			if(choix == max-2)affichage_fleche(2);
			
			nom_chapitre(choix);
			
			ML_display_vram();
			
			timer();
		}
		
		if(IsKeyUp(KEY_CTRL_LEFT) && gauche == 1)
		{
			gauche = 0;
			if(choix > 2)chgt_fleche(1);
		}
		
		ML_display_vram();

		
		if(permission_quitter == 0 && IsKeyDown(KEY_CTRL_EXE))	//Si le joueur a appuye sur "exe" pour se diriger vers un chapitre
		{
			clear();
			
			sous_menu();	//Affiche les graphismes des sous-menus, puis mne vers les differentes sections
			
			switch(choix)
			{
				case 1:
					suite();
					break;
				case 2:
					complexes();
					break;
				case 3:
					limites();
					break;
				case 4:
					derivation();
					break;
				case 5:
					expo();
					break;
				case 6:
					ln();
					break;
				case 7:
					trigo();
					break;
				case 8:
					integration();
					break;
				case 9:
					geometrie();
					break;
				case 10:
					proba();
					break;
				case 11:
					loi_proba();	
					break;
				case 12:
					estimation();	
					break;
				case 13:
					arithmetique();
					break;
			}

			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				aff_menu_principal(choix,max);
			}
			
			permission_quitter = 1;
			droite = 0;
			gauche = 0;
			
		}
	
		ML_display_vram();
	
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" pour pouvoir refaire un choix
			permission_quitter = 0;
		
    		if((permission_quitter == 0 && IsKeyDown(KEY_CTRL_MENU)) || (IsKeyDown(KEY_CTRL_EXIT) && permission_quitter == 0))
		{
			clear();
			
			maintien_fonction = 0;
		}
		
		if(IsKeyDown(KEY_CTRL_F1) && IsKeyDown(KEY_CTRL_F5))
		{
			clear();
			
			brazzers();
			
			maintien_fonction = 0;
		}

	}
	
	return 0;
	

}

void aff_menu_principal(int choix, int max)
{
	int i = 0;
	
	for(i = 1 ; i < 16 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(39,5,"Maths Ts",1);
	
	affichage_menu_principal(choix, max);
	
	nom_chapitre(choix);
}

void timer()
{
	int i = 0;

	for(i = 1 ; i <800000 ; i++)
	{
	}
}


void nom_chapitre(int choix)		
{
	int i = 0, j = 0;
			
	for(i = 0 ; i < 10 ; i++)ML_line(1,52+i,127,52+i,ML_WHITE); 						//Effacage nom du chapitre
	for(j = 0 ; j < 65 ; j+=64)for(i = 0 ; i < 14 ; i++)ML_line(24+j,26+i,38+j,26+i,ML_WHITE);	//Effacage contenu des deux petits carres
	for(i = 0 ; i < 22 ; i++)ML_line(52,23+i,74,23+i,ML_WHITE);						//Effacage du grand carre
		
	switch(choix)
	{
		case 1:
			PrintMini(31,54,"Suites numeriques",1);
			PrintMini(60,32,"Un",1);
			break;
		case 2:
			PrintMini(26,54,"Nombres Complexes",1);
			PrintMini(28,31,"Un",1);
			PrintMini(62,32,"Z",1);
			break;
		case 3:
			PrintMini(51,54,"Limites",1);	
			PrintMini(58,32,"lim",1);
			break;
		case 4:
			PrintMini(45,54,"Derivation",1);
			PrintMini(61,32,"f'",1);
			break;
		case 5:
			PrintMini(38,54,"Exponentielle",1);
			PrintMini(60,32,"e",1);
			PrintMini(64,30,"x",1);
			break;
		case 6:
			PrintMini(25,54,"Logarithme Neperien",1);
			PrintMini(59,32,"ln",1);
			break;
		case 7:
			PrintMini(37,54,"Trigonometrie",1);
			PrintMini(58,32,"cos",1);
			break;
		case 8:
			PrintMini(21,54,"Integrale et primitive",1);
			ML_line(59,30,59,38,ML_BLACK);
			ML_pixel(58,38,ML_BLACK);
			ML_pixel(60,29,ML_BLACK);
			PrintMini(62,32,"dx",1);
			break;
		case 9:
			PrintMini(19,54,"Geometrie dans l'espace",1);
			PrintMini(62,33,"u",1);
			ML_line(62,31,66,31,ML_BLACK);
			ML_line(64,30,64,33,ML_BLACK);
			break;
		case 10:
			PrintMini(11,54,"Probabilites conditionnelles",1);
			PrintMini(57,32,"P(A)",1);
			break;
		case 11:
			PrintMini(28,54,"Lois de probabilites",1);
			lambda(60,32);
			break;
		case 12:
			PrintMini(45,54,"Estimation",1);
			PrintMini(60,32,"In",1);
			break;
		case 13:
			PrintMini(29,54,"SPE - Arithmetique",1);
			PrintMini(59,32,"[k]",1);
			break;
			
			
	}	
	
	if(choix == 1 || choix == 3)PrintMini(126-32*choix,31,"Z",1);
	if(choix == 2 || choix == 4)PrintMini(90-32*(choix-2),31,"lim",1);
	if(choix == 3 || choix == 5)PrintMini(93-32*(choix-3),31,"f'",1);
	if(choix == 4 || choix == 6)
	{
	 	PrintMini(92-32*(choix-4),31,"e",1);
	 	PrintMini(96-32*(choix-4),29,"x",1);
	}
	if(choix == 5 || choix == 7)PrintMini(91-32*(choix-5),31,"ln",1);
	if(choix == 6 || choix == 8)PrintMini(90-32*(choix-6),31,"cos",1);
	if(choix == 7 || choix == 9)
	{
		ML_line(91-32*(choix-7),29,91-32*(choix-7),37,ML_BLACK);
		ML_pixel(90-32*(choix-7),37,ML_BLACK);
		ML_pixel(92-32*(choix-7),28,ML_BLACK);
		PrintMini(93-32*(choix-7),31,"dx",1);
	}
	if(choix == 8 || choix == 10)
	{
		PrintMini(94-32*(choix-8),32,"u",1);
		ML_line(94-32*(choix-8),30,98-32*(choix-8),30,ML_BLACK);
		ML_line(96-32*(choix-8),29,96-32*(choix-8),32,ML_BLACK);
	}
	if(choix == 9 || choix == 11)PrintMini(89-32*(choix-9),31,"P(A)",1);
	if(choix == 10 || choix == 12)lambda(92-32*(choix-10),31);
	if(choix == 11 || choix == 13)PrintMini(92-32*(choix-11),31,"In",1);
	if(choix == 12 || choix == 14)PrintMini(91-32*(choix-12),31,"[k]",1);
	
	
}

void chgt_fleche(int numero)  	//1 correspond a celle de gauche et 2 a celle de droite
{
	int i = 0;
	
	if(numero == 1)
		for(i = 0 ; i <4 ; i++)ML_line(5+i,33-i,5+i,34+i,ML_XOR);
	else
		for(i = 0 ; i <4 ; i++)ML_line(122-i,33-i,122-i,34+i,ML_XOR);
}

void fleches(int choix, int max)
{
	if(choix > 2)affichage_fleche(1);
	
	if(choix<max-1)affichage_fleche(2);
}

void affichage_fleche(int numero)  //1 correspond a la fleche de gauche et 2 a la fleche de droite
{
	if(numero == 1)
	{
		ML_line(5,32,10,27,ML_XOR);
		ML_line(4,33,10,39,ML_XOR);
		ML_line(9,29,9,38,ML_XOR);
	}
	
	if(numero == 2)
	{
		ML_line(122,32,117,27,ML_XOR);
		ML_line(123,33,117,39,ML_XOR);
		ML_line(118,29,118,38,ML_XOR);
	}
}

void affichage_menu_principal(int choix, int max)
{
	int i = 0, j = 0;
	
	ML_line(51,22,51,46,ML_BLACK);
	ML_line(51,22,75,22,ML_BLACK);
	ML_line(51,46,76,46,ML_BLACK);
	ML_line(75,22,75,46,ML_BLACK);
	
	if(choix == 1)
		affichage_carre_menu(2);
	else if(choix == max)
		affichage_carre_menu(1);
	else
	{
		for(i = 0 ; i < 100 ; i+=64)
		{
			ML_line(23+i,25,23+i,41,ML_BLACK);
			ML_line(23+i,25,39+i,25,ML_BLACK);
			ML_line(23+i,41,40+i,41,ML_BLACK);
			ML_line(39+i,25,39+i,41,ML_BLACK);
		}
	}
	
	fleches(choix,max);
	
}

void affichage_carre_menu(int numero)	//1 pour la gauche et 2 pour la droite
{
	int i = 0;
	
	if(numero == 1)
	{
		ML_line(23,26,23,41,ML_XOR);
		ML_line(23,25,39,25,ML_XOR);
		ML_line(23,41,40,41,ML_XOR);
		ML_line(39,25,39,41,ML_XOR);	
	}
	
	if(numero == 2)
	{
		ML_line(87,26,87,41,ML_XOR);
		ML_line(87,25,103,25,ML_XOR);
		ML_line(87,41,104,41,ML_XOR);
		ML_line(103,25,103,41,ML_XOR);
	}
	
}

void clear()		//Tout effacer
{
	ML_clear_screen();
	ML_clear_vram();
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
