#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void trigo()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	
	
	PrintXY(25,6,"Trigonometrie",1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				trigo_cours();
	
			if(choix == 2)
				trigo_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(25,6,"Trigonometrie",1);
			}

			permission_quitter = 0;

			ML_display_vram();
		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	
	}
}

void trigo_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(6,1);
	
	PrintXY(24,6,"Trigo : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 6  && position == 1)
		{
			choix += 1;
			choix_cours(choix,6);
			choix_cours(choix-1,6);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,6);
			choix_cours(choix+1,6);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,6);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,6);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(46,34,"Equations",0);
						break;
					case 2:
						PrintMini(47,34,"Formules",0);
						break;
					case 3:
						PrintMini(51,34,"Periode",0);
						break;
					case 4:
						PrintMini(53,34,"Parite",0);
						break;
					case 5:
						PrintMini(46,34,"Derivation",0);
						break;
					case 6:
						PrintMini(29,34,"fonction tangente",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 1;		//Nombre de pages predominant
			
			switch(choix)
			{
				case 1:
					pages = 3;
					PrintMini(46,4,"Equations",0);
					break;
				case 2:
					pages = 7;
					PrintMini(47,4,"Formules",0);
					break;
				case 3:
					PrintMini(51,4,"Periode",0);
					break;
				case 4:
					pages = 2;
					PrintMini(53,4,"Parite",0);
					break;
				case 5:
					pages = 2;
					PrintMini(46,4,"Derivation",0);
					break;
				case 6:
					PrintMini(29,4,"fonction tangente",0);
					break;
			}
			
			for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{	
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
			
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 16 ; i <50 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Pour tout reel x et entier",1);
									PrintMini(4,26,"relatif k :",1);
									PrintMini(4,34,"cos(x) = 0    x = k",1);
									equivaut(45,34);
									pi(78,34);
									PrintMini(4,42,"sin(x) = 0    x = (",1);
									pi(76,42);
									PrintMini(82,42,"/2) + k",1);
									equivaut(45,42);
									pi(109,42);
									break;
								
								case 2:
									PrintMini(4,18,"Pour tout reel x et a :",1);
									PrintMini(4,26,"sin(x) = sin(a)",1);
									equivaut(4,38);
									ML_line(15,34,15,48,ML_BLACK);
									PrintMini(18,34,"x = a + 2k",1);
									pi(57,34); 
									PrintMini(18,42,"x =   - a + 2k",1);
									pi(34,42);
									pi(73,42); 
									break;
									
								case 3:
									PrintMini(4,18,"Pour tout reel x et a :",1);
									PrintMini(4,26,"cos(x) = cos(a)",1);
									equivaut(4,38);
									ML_line(15,34,15,48,ML_BLACK);
									PrintMini(18,34,"x = a + 2k",1);
									pi(57,34); 
									PrintMini(18,42,"x = -a + 2k",1);
									pi(61,42); 
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"sin(a+b) = sin(a) * cos(b) +",1);
									PrintMini(4,26,"sin(b) * cos(a)",1);
									PrintMini(4,34,"sin(a-b) = sin(a) * cos(b) -",1);
									PrintMini(4,42,"sin(b) * cos(a)",1);
									break;
								
								case 2:
									PrintMini(4,18,"cos(a+b) = cos(a) * cos(b) -",1);
									PrintMini(4,26,"sin(a) * sin(b)",1);
									PrintMini(4,34,"cos(a-b) = cos(a) * cos(b) +",1);
									PrintMini(4,42,"sin(a) * sin(b)",1);
									break;
									
								case 3:
									PrintMini(4,18,"Pour tout x sur |R :",1);
									PrintMini(4,28,"[cos(x)]  + [sin(x)]  = 1",1);
									PrintMini(32,26,"2",1);
									PrintMini(76,26,"2",1);
									PrintMini(4,38,"sin(2x) = 2 * sin(x) * cos(x)",1);
									break;
								
								case 4:
									PrintMini(43,18,"2 * [cos(x)]  -1",1);
									PrintMini(89,16,"2",1);
									PrintMini(4,28,"cos(2x) =",1);
									PrintMini(43,28,"1 - 2 * [sin(x)]",1);
									PrintMini(104,26,"2",1);
									PrintMini(43,38,"[cos(x)]  - [sin(x)]",1);
									PrintMini(71,36,"2",1);
									PrintMini(115,36,"2",1);
									ML_line(40,18,40,42,ML_BLACK);
									break;
								
								case 5:
									PrintMini(4,18,"cos(",1);
									pi(19,18);
									PrintMini(25,18,"/2 + x) = -sin(x)",1);
									PrintMini(4,26,"sin(",1);
									pi(19,26);
									PrintMini(25,26,"/2 + x) = cos(x)",1);
									PrintMini(4,34,"cos(",1);
									pi(19,34);
									PrintMini(25,34,"/2 - x) = sin(x)",1);
									PrintMini(4,42,"sin(",1);
									pi(19,42);
									PrintMini(25,42,"/2 - x) = cos(x)",1);
									
									break;
								
								case 6:
									PrintMini(4,18,"cos(",1);
									pi(19,18);
									PrintMini(27,18,"+ x) = -cos(x)",1);
									PrintMini(4,26,"sin(",1);
									pi(19,26);
									PrintMini(27,26,"+ x) = -sin(x)",1);
									PrintMini(4,34,"cos(",1);
									pi(19,34);
									PrintMini(27,34,"- x) = -cos(x)",1);
									PrintMini(4,42,"sin(",1);
									pi(19,42);
									PrintMini(27,42,"- x) = sin(x)",1);
									break;
								
								case 7:
									PrintMini(4,18,"cos(-x) = cos(x)",1);
									PrintMini(4,26,"sin(-x) = -sin(x)",1);
				
									break;
								
								case 8:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"cos et sin sont des fonctions",1);
									PrintMini(4,26,"periodiques de periode 2",1);
									pi(96,26);
									PrintMini(4,34,"cos(x) = cos(x + 2",1);
									pi(73,34);
									PrintMini(79,34,")",1);
									PrintMini(4,42,"sin(x) = sin(x + 2",1);
									pi(71,42);
									PrintMini(77,42,")",1);
									break;
								
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"La fonction f(x) est paire si",1);
									PrintMini(4,26,"f(-x) = f(x)",1);
									PrintMini(4,34,"La fonction cosinus est paire",1);
									PrintMini(4,42,"cos(-x) = cos(x)",1);
									break;
								
								case 2:
									PrintMini(4,18,"La fonction f(x) est impaire si",1);
									PrintMini(4,26,"f(-x) = -f(x)",1);
									PrintMini(4,34,"La fonction sinus est impaire",1);
									PrintMini(4,42,"sin(-x) = -sin(x)",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Les fonction cos et sin sont",1);
									PrintMini(4,26,"derivables sur |R :",1);
									PrintMini(4,34,"[cos(x)]' = -sin(x)",1);
									PrintMini(4,42,"[sin(x)]' = cos(x)",1);
									break;
									
								case 2:
									PrintMini(4,18,"Soit u une fonction derivable",1);
									PrintMini(4,26,"sur I :",1);
									PrintMini(4,34,"[cos(u)]' = -u'*sin(u)",1);
									PrintMini(4,42,"[sin(x)]' = u'*cos(u)",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 6:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"La fonction tangente est ",1);
									PrintMini(4,26,"definie sur |R/{k*(",1);
									pi(77,26);
									PrintMini(83,26,"/2)} par :",1);
									PrintMini(4,36,"tan(x) = [sin(x)]/[cos(x)]",1);
									break;
									
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(6,choix);
				PrintXY(24,6,"Trigo : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void trigo_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(8,6,"Trigo. : questions",1);
	
	question();
	
	case_question_trigo(2);
	case_question(1,2);
	
	affichage_question_trigo(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 3 && retour == 0)
		{
			choix ++;
			
			case_question(choix - 1 , milieu);
			case_question(choix,milieu);	
			affichage_question_trigo(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			case_question(choix + 1 , milieu);
			case_question(choix , milieu);
			affichage_question_trigo(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			pages = 2;
			
			switch(choix)
			{
				case 1:
					pages = 3;
					PrintMini(39,4,"Periode",1);
					break;
				case 2:
					PrintMini(39,4,"Parite",1);
					break;
				case 3:
					PrintMini(39,4,"Derive",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <51 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour demontrer qu'un certain",1);
									PrintMini(4,22,"reel A est la periode d'une",1);
									PrintMini(4,30,"fonction f, il faut prouver",1);
									PrintMini(4,38,"que f(x) = f(x + A)",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple :",1);
									PrintMini(4,22,"f(x) = cos (2x) + cos(2x) - 1",1);
									PrintMini(42,20,"2",1);
									PrintMini(4,30,"Montrons qu'une periode de",1);
									PrintMini(4,38,"f est",1);
									pi(26,38);
									PrintMini(4,46,"f(x+",1);
									pi(20,46);
									PrintMini(26,46,") = cos (2x+2",1);
									PrintMini(53,44,"2",1);
									pi(76,46);
									PrintMini(82,46,")+cos(.)-1",1);
									break;
								
								case 3:
									PrintMini(4,14,"Au final on remarque que :",1);
									PrintMini(4,22,"f(x+",1);
									pi(19,22);
									PrintMini(25,22,") = f(x). Donc   est une",1);
									pi(82,22);
									PrintMini(4,30,"periode de la fonction f",1);
									break;
				
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour etudier la parite de la",1);
									PrintMini(4,22,"fonction f, il faut calculer",1);
									PrintMini(4,30,"f(-x). Si f(-x) = f(x) alors f",1);
									PrintMini(4,38,"est paire. Si f(-x) = -f(x),",1);
									PrintMini(4,46,"alors f est impaire",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : f(x) = cos(2x)",1);
									PrintMini(4,22,"f(-x) = cos(-2x) = cos(2x)",1);
									PrintMini(4,30,"Ainsi la fonction f est paire",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Soit u une fonction derivable",1);
									PrintMini(4,22,"sur I :",1);
									PrintMini(4,30,"[cos(u)]' = -u'*sin(u)",1);
									PrintMini(4,38,"[sin(x)]' = u'*cos(u)",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple :",1);
									PrintMini(4,22,"f(x) = 2cos(3x) + 3sin(4x)",1);
									PrintMini(4,30,"f est defini et derivable",1);
									PrintMini(4,38,"sur |R :",1);
									PrintMini(4,46,"f'(x) = 6cos(3x) + 12sin(4x)",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(8,6,"Trigo. : questions",1);
		
				question();
				
				case_question_trigo(milieu);
				case_question(choix,milieu);
				affichage_question_trigo(choix);	
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_trigo(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	PrintMini(12,26,"Periode",0);
	PrintMini(14,38, "Parite", 0);
	PrintMini(14,50, "Derive", 0);
}

void affichage_question_trigo(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Demontrer",0);
			PrintMini(54,32,"qu'une",0);
			PrintMini(54,38,"fonction a",0);
			PrintMini(54,44,"pour periode",0);
			PrintMini(54,50,"un reel",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Etudier la",0);
			PrintMini(54,32,"parite d'une",0);
			PrintMini(54,38,"fonction",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Trouver la",0);
			PrintMini(54,32,"derive d'une",0);
			PrintMini(54,38,"fonction",0);
			PrintMini(54,44,"trigo.",0);
			break;
	}
}