#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void arithmetique()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	
	
	PrintXY(28,6,"Arithmetique",1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				arithmetique_cours();
	
			if(choix == 2)
				arithmetique_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(28,6,"Arithmetique",1);
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	
	}
}

void arithmetique_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(5,1);
	
	PrintXY(27,6,"Ari. : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 5  && position == 1)
		{
			choix += 1;
			choix_cours(choix,5);
			choix_cours(choix-1,5);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,5);
			choix_cours(choix+1,5);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,5);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,5);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(36,34,"Division dans Z",0);
						break;
					case 2:
						PrintMini(43,34,"Congruence",0);
						break;
					case 3:
						PrintMini(56,34,"PGCD",0);
						break;
					case 4:
						PrintMini(17,34,"Equations diophantiennes",0);
						break;
					case 5:
						PrintMini(29,34,"Nombres premiers",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			switch(choix)
			{
				case 1:
					pages = 4;
					PrintMini(36,4,"Division dans Z",0);
					break;
				case 2:
					pages = 5;
					PrintMini(43,4,"Congruence",0);
					break;
				case 3:
					pages = 6;
					PrintMini(56,4,"PGCD",0);
					break;
				case 4:
					pages = 3;
					PrintMini(17,4,"Equations diophantiennes",0);
					break;
				case 5:
					pages = 1;
					PrintMini(29,4,"Nombres premiers",0);
					break;
				}
			
			if(choix == 4)		//Affichage des deux bandes noires
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,11+116*j,i,ML_BLACK);
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 16 ; i <50 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"On dit que l'entier relatif a",1);
									PrintMini(4,26,"divise l'entier relatif b s'il",1);
									PrintMini(4,34,"existe un entier relatif k",1);
									PrintMini(4,42,"tel que b = ka",1);
									break;
								
								case 2:
									PrintMini(4,18,"Tout entier relatif a (excepte",1);
									PrintMini(4,26,"1 et -1) admet au moins 4",1);
									PrintMini(4,34,"diviseurs : a, -a, 1 et -1",1);
									break;
								
								case 3:
									PrintMini(4,18,"On appelle combinaison",1);
									PrintMini(4,26,"lineaire de deux entiers",1);
									PrintMini(4,34,"relatifs a et b tout entier",1);
									PrintMini(4,42,"de la forme au + bv",1);
									break;
								
								case 4:
									PrintMini(4,18,"La division euclidienne de",1);
									PrintMini(4,26,"a par b est : a = bq + r",1);
									PrintMini(4,34,"avec q le quotient et r le",1);
									PrintMini(4,42,"reste",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Deux entiers relatifs a et b",1);
									PrintMini(4,26,"sont congrus modulo n si",1);
									PrintMini(4,34,"a - b est divisible par n",1);
									PrintMini(4,42,"On ecrit a   b[n]",1);
									congru(47,42);
									break;
								
								case 2:
									PrintMini(4,18,"a   b[n] si et seulement si",1);
									congru(11,18);
									PrintMini(4,26,"il existe un entier relatif k",1);
									PrintMini(4,34,"tel que a = b + kn",1);
									break;
									
								case 3:
									PrintMini(4,18,"a   a[n]",1);
									congru(11,18);
									PrintMini(4,26,"Si a   b[n] alors b   a[n]",1);
									congru(21,26);
									congru(81,26);
									PrintMini(4,34,"Si a   b[n] et b   c[n]",1);
									congru(21,34);
									congru(68,34);
									PrintMini(4,42,"alors a   c[n]",1);
									congru(36,42);
									break;
								
								case 4:
									PrintMini(4,18,"Si a   c[n] et b   d[n] alors :",1);
									congru(21,18);
									congru(68,18);
									PrintMini(4,26,"a + b   (c + d)[n]",1);
									congru(27,26);
									PrintMini(4,34,"a - b   (c - d)[n]",1);
									congru(27,34);
									PrintMini(4,42,"a * b   (c * d)[n]",1);
									congru(29,42);
									break;
								
								case 5:
									PrintMini(4,18,"Si a   b[n], alors, pour entier",1);
									congru(21,18);
									PrintMini(4,26,"relatif k :",1);
									PrintMini(4,34,"ka   kb[n]",1);
									congru(15,34);
									PrintMini(4,42,"a    b [n]",1);
									PrintMini(8,40,"k",1);
									congru(15,42);
									PrintMini(28,40,"k",1);
									break;
									
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"L'ensemble des diviseurs",1);
									PrintMini(4,26,"communs des entiers a et b",1);
									PrintMini(4,34,"est l'ensemble des entiers",1);
									PrintMini(4,42,"divisant a la fois a et b",1);
									break;
								
								case 2:
									PrintMini(4,18,"Le plus grand diviseur commun",1);
									PrintMini(4,26,"(PGCD) des nombres entiers a",1);
									PrintMini(4,34,"et b est le plus grand ",1);
									PrintMini(4,42,"element de cet ensemble",1);
									break;
								
								case 3:
									PrintMini(4,18,"Il est note : PGCD(a,b)",1);
									PrintMini(4,26,"PGCD(a,b) = PGCD(b,a)",1);
									PrintMini(4,34,"PGCD(a,b)   1",1);
									signe_superieur_egal(41,34);
									PrintMini(4,42,"PGCD(a,0) = |a|",1);
									break;
									
								case 4:
									PrintMini(4,18,"Si a = bq + r, alors :",1);
									PrintMini(4,26,"PGCD(a,b) = PGCD(b,r)",1);
									PrintMini(4,34,"Si b divise a, alors :",1);
									PrintMini(4,42,"PGCD(a,b) = b",1);
									break;
									
								case 5:
									PrintMini(4,18,"PGCD(ka,kb) = |k|*PGCD(a,b)",1);
									PrintMini(4,26,"Si d = PGCD(a,b) alors il existe",1);
									PrintMini(4,34,"des entiers a' et b' premiers",1);
									PrintMini(4,42,"entre eux : a = da' et b = db'",1);
									break;
								
								case 6:
									PrintMini(4,18,"Si PGCD(a,b) = d, alors il",1);
									PrintMini(4,26,"existe un couple  (u,v) d'entiers",1);
									PrintMini(4,34,"relatifs tel que au + bv = d",1);
									PrintMini(4,42,"ce couple n'est pas unique",1);
									break;
								
								case 7:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Une equation diophantienne",1);
									PrintMini(4,26,"est une equation de la forme ",1);
									PrintMini(4,34,"ax + by = c d'inconnues x et y",1);
									PrintMini(4,42,"(entiers relatifs)",1);
									break;
								
								case 2:
									PrintMini(4,18,"Cette equation admet des",1);
									PrintMini(4,26,"solutions si et seulement si",1);
									PrintMini(4,34,"il existe un entier relatif k",1);
									PrintMini(4,42,"tel que PGCD(a,b) = kc",1);
									break;
									
								case 3:
									PrintMini(4,18,"Si (x0,y0) est une solution de",1);
									PrintMini(4,26,"cette equation, alors pour",1);
									PrintMini(4,34,"tout entier relatif k : ",1);
									PrintMini(4,42,"x = x0 - kb et y = y0 + ka",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Un nombre entier naturel",1);
									PrintMini(4,26,"(sauf 1) est premier s'il ",1);
									PrintMini(4,34,"possede exactement deux ",1);
									PrintMini(4,42,"diviseurs : 1 et lui meme",1);
									break;
								
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(5,choix);
				PrintXY(27,6,"Ari. : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void arithmetique_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(15,6,"Ari. : questions",1);
	
	question();
	
	case_question_arithmetique(2);
	case_question(1,2);
	
	affichage_question_arithmetique(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 3 && retour == 0)
		{
			choix ++;
			
			case_question(choix - 1 , milieu);
			case_question(choix,milieu);	
			affichage_question_arithmetique(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			case_question(choix + 1 , milieu);
			case_question(choix , milieu);
			affichage_question_arithmetique(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			pages = 4;
			
			switch(choix)
			{
				case 1:
					PrintMini(39,4,"Congruences",1);
					break;
				case 2:
					PrintMini(39,4,"Calcul du PGCD",1);
					break;
				case 3:
					pages = 7;
					PrintMini(39,4,"Equation diophantienne",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <51 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour utiliser les congruences",1);
									PrintMini(4,22,"il faut consulter les formules",1);
									PrintMini(4,30,"presentes dans la partie",1);
									PrintMini(4,38,"cours",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Determiner les",1);
									PrintMini(4,22,"reste de la division par 7 de",1);
									PrintMini(4,31,"50    + 100    :",1);
									PrintMini(12,29,"100      100",1);
									PrintMini(4,38,"On a 50 = 7*7 + 1, donc",1);
									PrintMini(4,46,"50   1[7], d'ou 50      1[7]",1);
									congru(16,46);
									PrintMini(72,44,"100",1);
									congru(87,46);
									break;
								
								case 3:
									PrintMini(4,14,"De plus 100 = 7*14 + 2",1);
									PrintMini(4,23,"Ainsi 100   2[7] ",1);
									congru(40,23);
									PrintMini(4,33,"D'ou 100      2   [7] ",1);
									PrintMini(35,31,"100",1);
									PrintMini(63,31,"100",1);
									congru(50,33);
									PrintMini(4,42,"Or 2    1[7] et 100=33*33+1",1);
									PrintMini(22,40,"3",1);
									congru(28,42);
									break;
								
								case 4:
									PrintMini(4,16,"Ainsi (2 )     1[7]",1);
									PrintMini(32,14,"3",1);
									PrintMini(39,13,"33",1);
									congru(50,16);
									PrintMini(4,25,"Donc 2      2[7]",1);
									PrintMini(28,23,"100",1);
									congru(43,25);
									PrintMini(4,34,"Par consequent 100      2[7]",1);
									PrintMini(79,32,"100",1);
									congru(94,34);
									PrintMini(4,43,"Donc 50    + 100      3[7]",1);
									PrintMini(33,41,"100      100",1);
									congru(84,43);
									break;
				
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"En utilisant la propriete",1);
									PrintMini(4,22,"PGCD(a,b) = PGCD(b,r), on peut",1);
									PrintMini(4,30,"trouver le PGCD de a et b",1);
									PrintMini(4,38,"par divisions euclidiennes",1);
									PrintMini(4,46,"successives",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Calcul du PGCD",1);
									PrintMini(4,22,"de 1386 et 1180 :",1);
									PrintMini(4,30,"1386 = 1180*1 + 206",1);
									PrintMini(4,38,"1180 = 206*5 + 150",1);
									PrintMini(4,46,"206 = 150*1 + 56",1);
									break;
								
								case 3:
									PrintMini(4,14,"150 = 56*2 + 38",1);
									PrintMini(4,22,"56 = 38*1 + 18",1);
									PrintMini(4,30,"38 = 18*2 + 2",1);
									PrintMini(4,38,"18 = 9*2",1);
									break;
								
								case 4:
									PrintMini(4,14,"Le PGCD de 1386 et 1180",1);
									PrintMini(4,22,"est le dernier reste non nul",1);
									PrintMini(4,30,"Donc PGCD(1386,1180) = 2",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour resoudre une equation",1);
									PrintMini(4,22,"diophantienne (E), il faut",1);
									PrintMini(4,30,"passer successivement par ",1);
									PrintMini(4,38,"quatre etapes presentes dans",1);
									PrintMini(4,46,"l'exemple",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : resoudre l'equation",1);
									PrintMini(4,22,"(E) : 4x - 3y = 5 ",1);
									PrintMini(4,30,"(avec x et y des entiers",1);
									PrintMini(4,38,"relatifs)",1);
									break;
								
								case 3:
									PrintMini(4,14,"On verifie que (E) admet au",1);
									PrintMini(4,22,"moins une solution :",1);
									PrintMini(4,30,"PGCD(4,-3) = PGCD(4,3) = 1",1);
									PrintMini(4,38,"Comme 1 divise 5, alors (E)",1);
									PrintMini(4,46,"admet au moins une solution",1);
									break;
								
								case 4:
									PrintMini(4,14,"On cherche le couple (x0,y0) :",1);
									PrintMini(4,22,"4 = 3*1 + 1",1);
									PrintMini(4,30,"4 - 3 = 1",1);
									PrintMini(4,38,"4*5 -3*5 = 5",1);
									PrintMini(4,46,"Donc (x0,y0) = (5,5)",1);
									break;
								
								case 5:
									PrintMini(4,14,"On cherche le couple (x,y) :",1);
									PrintMini(4,22,"On a 4x-3y=5 et 4x0-3y0=5",1);
									PrintMini(4,30,"Donc 4(x-x0) = 3(y-y0)",1);
									PrintMini(4,38,"PGCD(4,3)=1, donc 4 divise",1);
									PrintMini(4,46,"(y-y0) et 3 divise (x-x0)",1);
									break;
									
								case 6:
									PrintMini(4,14,"Ainsi il existe un entier",1);
									PrintMini(4,22,"relatif k tel que y-y0=4k",1);
									PrintMini(4,30,"et x-x0=3k",1);
									PrintMini(4,38,"On a x=3k+x0 et y=4k+y0",1);
									PrintMini(4,46,"Donc x=3k+5 et y=4k+5",1);
									break;
									
								case 7:
									PrintMini(4,14,"Enfin on demontre la",1);
									PrintMini(4,22,"reciproque :",1);
									PrintMini(4,30,"4(3k+5) - 3(4k+5) = 5",1);
									PrintMini(4,38,"La reciproque est vraie, donc",1);
									PrintMini(4,46,"(x,y) est bien solution de (E)",1);
									break;
									
								case 8:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(15,6,"Ari. : questions",1);
		
				question();
				
				case_question_arithmetique(milieu);
				case_question(choix,milieu);
				affichage_question_arithmetique(choix);	
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_arithmetique(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	PrintMini(12,26,"Congru.",0);
	PrintMini(18,38, "PGCD", 0);
	PrintMini(11,50, "Equation", 0);
}

void affichage_question_arithmetique(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Savoir bien",0);
			PrintMini(54,32,"utiliser les",0);
			PrintMini(54,38,"congruences",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Trouver le",0);
			PrintMini(54,32,"PGCD de deux",0);
			PrintMini(54,38,"entiers par",0);
			PrintMini(54,44,"divisions",0);
			PrintMini(54,50,"successives",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Resoudre une",0);
			PrintMini(54,32,"equation",0);
			PrintMini(54,38,"diophantienne",0);
			break;
	}
	
}
