#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void complexes()		//chapitre sur les nombres complexes
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	//Affichage du menu des complexes
	
	PrintXY(37,6,"Complexes",1);	
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
			{
				complexes_cours();
				for(i  = 20 ; i < 63 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Pour ne pas effacer l'entete
			}
			else
			{
				complexes_question();
				clear();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(37,6,"Complexes",1);	
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}

		ML_display_vram();	
	}	
}

void complexes_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int maintien_fonction_choix_cours = 1, choix_choix_cours = 1, position_choix_cours = 1; 	//Variables pour le choix de la partie (complexes ou arguments)
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1, nombre_pages = 1; 		//Variables pour le menu des cours
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_choix_cours_complexe(0);	
	affichage_complexe_choix_cours(1);
						
	ML_display_vram();
	
	while(maintien_fonction_choix_cours)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction_choix_cours = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;

		if(IsKeyDown(KEY_CTRL_RIGHT) && choix_choix_cours == 1 && position_choix_cours == 1)
		{
			choix_choix_cours = 2;
			affichage_complexe_choix_cours(1);
			affichage_complexe_choix_cours(2);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix_choix_cours == 2 && position_choix_cours == 1)
		{
			choix_choix_cours = 1;
			affichage_complexe_choix_cours(1);
			affichage_complexe_choix_cours(2);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_DOWN) && position_choix_cours == 1)
		{
			position_choix_cours = 2;
			affichage_complexe_choix_cours(choix_choix_cours);
			affichage_complexe_choix_cours(3);
			ML_display_vram();
		
			timer();
		}

		if(IsKeyDown(KEY_CTRL_UP) && position_choix_cours == 2)
		{
			position_choix_cours = 1;
			affichage_complexe_choix_cours(choix_choix_cours);
			affichage_complexe_choix_cours(3);
			ML_display_vram();
		
			timer();
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && position_choix_cours == 2 && permission_quitter) ||(IsKeyDown(KEY_CTRL_EXIT) && permission_quitter))
			maintien_fonction_choix_cours = 0;
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && position_choix_cours == 1)
		{
			clear();
			
			permission_quitter = 0;
			
			nombre_pages = 9- 2*choix_choix_cours;	//7 pages si c'est les nombres complexes, 5 si c'est la partie argument
			
			affichage_menu_cours(nombre_pages,1);
		
			PrintXY(12,6,"Complexes : cours",1);
	
			while(maintien_fonction)
			{	
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && choix != nombre_pages  && position == 1)
				{
					choix += 1;
					choix_cours(choix,nombre_pages);
					choix_cours(choix-1,nombre_pages);
					affichage = 1;
					
					timer();
				}
				
				if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
				{
					choix -= 1;
					choix_cours(choix,nombre_pages);
					choix_cours(choix+1,nombre_pages);
					affichage = 1;
				
					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
				{
					position = 2;
					affichage = 1;
					retour_cours();
					choix_cours(choix,nombre_pages);
				}
			
				if(IsKeyDown(KEY_CTRL_UP) && position == 2)
				{
					position = 1;
					affichage = 1;
					retour_cours();
					choix_cours(choix,nombre_pages);
				}
			
				if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction = 0;
				
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
					permission_quitter = 1;
				
				if(affichage == 1)
				{
					for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
						
					if(position == 1)		// Affichage du titre de la section
					{
						if(choix_choix_cours == 1)
						{	
							switch(choix)		//Affichage nom de la partie et determination du nombre de pages
							{
								case 1:
									PrintMini(46,34,"Definition",0);
									break;
								case 2:
									PrintMini(47,34,"Formules",0);;
									break;
								case 3:
									PrintMini(51,34,"Module",0);
									break;
								case 4:
									PrintMini(24,34,"Egalite de complexes",0);
									break;
								case 5:
									PrintMini(21,34,"Equation de 2nd degre",1);	
									break;
								case 6:
									PrintMini(37,34,"plan complexe",1);
									break;
								case 7:
									PrintMini(45,34,"Geometrie",1);	
									break;
							}
						}
						else
						{	
							switch(choix)
							{
								case 1:
									PrintMini(46,34,"Definition",1);	
									break;
								case 2:
									PrintMini(21,34,"Forme trigonometrique",1);
									break;
								case 3:
									PrintMini(44,34,"Proprietes",1);	
									break;
								case 4:
									PrintMini(24,34,"Forme exponentielle",1);	
									break;
								case 5:
									PrintMini(45,34,"Geometrie",1);	
									break;
							}
						}	
					}	
					else
						PrintMini(35,34,"Retour au menu",0);
					
					affichage = 0;
				}
	
				ML_display_vram();
			
				if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
				{
					clear();
				
					pages = 3;		//Nombre de pages predominant
					
					if(choix_choix_cours == 1)
					{	
						switch(choix)		//Affichage nom de la partie et determination du nombre de pages
						{
							case 1:
								PrintMini(46,4,"Definition",1);	
								pages = 1;
								break;
							case 2:
								PrintMini(47,4,"Formules",1);
								pages = 4;
								break;
							case 3:
								PrintMini(50,4,"Module",1);	
								pages = 3;
								break;
							case 4:
								PrintMini(52,4,"Egalite",1);
								pages = 1;
								break;
							case 5:
								PrintMini(21,4,"Equation de 2nd degre",1);	
								pages = 3;
								break;
							case 6:
								PrintMini(37,4,"plan complexe",1);
								pages = 2;
								break;
							case 7:
								PrintMini(45,4,"Geometrie",1);	
								pages = 5;
								break;
						}
					}
					else
					{	
						switch(choix)
						{
							case 1:
								PrintMini(46,4,"Definition",1);	
								pages = 2;
								break;
							case 2:
								PrintMini(21,4,"Forme trigonometrique",1);
								pages = 1;
								break;
							case 3:
								PrintMini(44,4,"Proprietes",1);	
								pages = 2;
								break;
							case 4:
								PrintMini(24,4,"Forme exponentielle",1);	
								pages = 1;
								break;
							case 5:
								PrintMini(45,4,"Geometrie",1);	
								pages = 4;
								break;
						}
					}
				
					if((choix_choix_cours == 1 && choix == 5) || (choix_choix_cours == 2 && choix == 2))		//Affichage bandes noires dans les parties du cours
						for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+112*j,i,14+114*j,i,ML_BLACK);
					else
						for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
				
					bouton_retour_cours();		//Affichage graphisme
					cours_pixel(pages);
					choix_page(1,pages);
				
					permission_quitter = 0;		//Remise a 0 des variables
					position_cours = 1;
					maintien_fonction_cours = 1;
					affichage_cours = 1;
					
					ML_display_vram();	
						
					while(maintien_fonction_cours)
					{
						
						if(IsKeyDown(KEY_CTRL_F6))
							maintien_fonction_cours = 0;
				
						if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
						{
							position_cours += 1;
							affichage_cours = 1;
					
							if(position_cours<pages+1)
								choix_page(position_cours,pages);
							else
								affichage_bouton_retour_cours();
					
							choix_page(position_cours-1,pages);
		
							timer();
						}
				
							if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
						{
							position_cours -= 1;
							affichage_cours = 1;
					
							choix_page(position_cours,pages);
					
							if(position_cours<pages)
								choix_page(position_cours+1,pages);
							else
								affichage_bouton_retour_cours();
					
							timer();
						}
			
						if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
							maintien_fonction_cours = 0;
			
						if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
			
						if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
					
						if(affichage_cours)
						{
							for(i = 16 ; i <51 ; i++)ML_line(2,i,127,i,ML_WHITE);
				
							if(choix_choix_cours == 1)
							{
								switch(choix)
								{
									case 1:		
									switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"Il existe un ensemble   :",1);
												comp(92,18);
												PrintMini(4,26,"L'ensemble des nombres",1);
												PrintMini(4,34,"complexes contenant |R tel que ",1);
												PrintMini(4,42,"i  = -1 et z = x + iy",1);
												PrintMini(7,40,"2",1);
												break;
											
											case 2:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
										
									case 2:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"Si z = x + iy, alors on appelle",1);
												PrintMini(4,26,"conjugue de z : z = x - iy",1);
												ML_line(68,25,71,25,ML_BLACK);
												PrintMini(4,34,"Si z est un reel : y = 0 :",1);
												PrintMini(4,42,"z = x d'ou z = z",1);
												ML_line(63,41,66,41,ML_BLACK);
												break;
											
											case 2:
												PrintMini(4,18,"Si z est un imaginaire pur :",1);
												PrintMini(4,26,"x = 0 : z = iy d'ou z = -z",1);
												ML_line(100,25,103,25,ML_BLACK);
												PrintMini(4,34,"z + z = 2x",1);
												ML_line(20,33,23,33,ML_BLACK);
												PrintMini(4,42,"z - z = 2iy",1);
												ML_line(20,41,23,41,ML_BLACK);
												break;
												
											case 3:
												PrintMini(4,18,"z * z = x  + y",1);
												ML_line(22,17,25,17,ML_BLACK);
												PrintMini(43,16,"2    2",1);
												PrintMini(4,28,"z + z' = z + z'",1);
												ML_line(4,27,23,27,ML_BLACK);
												ML_line(39,27,42,27,ML_BLACK);
												ML_line(55,27,58,27,ML_BLACK);
												PrintMini(4,38,"z * z' = z * z'",1);
												ML_line(4,37,25,37,ML_BLACK);
												ML_line(41,37,44,37,ML_BLACK);
												ML_line(59,37,62,37,ML_BLACK);
												break;
											
											case 4:
												PrintMini(4,20,"z   = (z)",1);
												PrintMini(9,18,"n",1);
												ML_line(4,17,12,17,ML_BLACK);
												ML_line(31,19,34,19,ML_BLACK);
												PrintMini(38,18,"n",1);
												parenthese(4,29,8);
												ML_line(5,28,15,28,ML_BLACK);
												PrintMini(8,30,"z",1);
												ML_line(7,36,13,36,ML_BLACK);
												PrintMini(7,38,"z'",1);
												PrintMini(20,34,"=",1);
												ML_line(27,36,35,36,ML_BLACK);
												PrintMini(29,30,"z",1);
												PrintMini(28,40,"z'",1);
												ML_line(29,29,32,29,ML_BLACK);
												ML_line(28,38,34,38,ML_BLACK);
											
											case 5:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
									
									case 3:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"On appelle module de z :",1);
												PrintMini(4,28,"|z| =  x  + y   avec |z|   0",1);
												signe_superieur_egal(95,28);
												PrintMini(32,27,"2",1);
												PrintMini(52,27,"2",1);
												racine_carre(22,25,33);
												PrintMini(4,36,"Si |z| = 0 alors z = 0",1);
												PrintMini(4,44,"|z| = |z|",1);
												ML_line(26,43,29,43,ML_BLACK);
												break;
											
											case 2:
												PrintMini(4,18,"Si z = x alors |z| = |x|",1);
												PrintMini(4,26,"Si z = iy alors |z| = |y|",1);
												PrintMini(4,34,"|z * z'| = |z| * |z'|",1);
												PrintMini(4,42,"|z ",1);
												PrintMini(15,42,"| = |z|",1);
												PrintMini(10,40,"n",1);
												PrintMini(37,40,"n",1);
												break;
												
											case 3:
												PrintMini(7,18,"z",1);
												PrintMini(6,26,"z'",1);
												ML_line(6,24,12,24,ML_BLACK);
												ML_line(4,18,4,32,ML_BLACK);
												ML_line(13,18,13,32,ML_BLACK);
												PrintMini(16,22,"=",1);
												PrintMini(24,18,"|z|",1);
												PrintMini(23,26,"|z'|",1);
												ML_line(23,24,33,24,ML_BLACK);
												PrintMini(4,36,"|z + z'|   |z| + |z'|",1);
												signe_inferieur_egal(34,36);
												break;
												
											case 4:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;	
										
									case 4:
										switch(position_cours)
										{
											case 1:
												PrintMini(3,18,"Si z = 0 alors x + iy = 0",1);
												PrintMini(3,26,"d'ou x = 0 et y = 0",1);
												PrintMini(3,34,"Si z = z' alors x + iy = x' + iy'",1);
												PrintMini(3,42,"d'ou x = x' et y = y'",1);
												break;
											
											case 2:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;	
									
									case 5:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"On a az  + bz + c = 0",1);	
												PrintMini(33,16,"2",1);
												delta(4,27);
												PrintMini(14,27,"= b  - 4ac",1);
												PrintMini(27,25,"2",1);
												PrintMini(4,36,"Si   = 0 alors z = -",1);
												ML_line(86,38,94,38,ML_BLACK);
												delta(13,36);
												PrintMini(88,31,"b",1);
												PrintMini(86,41,"2a",1);
												break;
											
											case 2:
												PrintMini(4,18,"Si     0 alors :",1);
												delta(13,18);
												PrintMini(23,18,">",1);
												PrintMini(4,34,"z =",1);
												PrintMini(7,36,"1",1);
												ML_line(18,36,55,36,ML_BLACK);
												PrintMini(20,29,"- b +",1);
												racine_carre(41,27,9);
												delta(45,29);
												PrintMini(31,38,"2a",1);
												PrintMini(64,34,"z  =",1);
												PrintMini(69,36,"2",1);
												ML_line(82,36,119,36,ML_BLACK);
												PrintMini(84,29,"- b -",1);
												racine_carre(105,27,9);
												delta(109,29);
												PrintMini(95,38,"2a",1);
												break;
												
											case 3:
												PrintMini(4,18,"Si     0 alors :",1);
												delta(13,18);
												PrintMini(23,18,"<",1);
												PrintMini(4,34,"z =",1);
												PrintMini(7,36,"1",1);
												ML_line(18,36,65,36,ML_BLACK);
												PrintMini(20,29,"- b + i ",1);
												PrintMini(52,30,"|",1);
												PrintMini(62,30,"|",1);
												racine_carre(47,27,15);
												delta(54,29);
												PrintMini(34,38,"2a",1);
												PrintMini(78,34,"z  = z",1);
												PrintMini(82,36,"2",1);
												PrintMini(101,36,"1",1);
												ML_line(98,33,104,33,ML_BLACK);
												break;
												
											case 4:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
										
									case 6:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"Le plan complexe est constitue",1);
												PrintMini(4,26,"de l'axe des reels (abscisses)",1);
												PrintMini(4,34,"et de l'axe des imaginaires",1);
												PrintMini(4,42,"purs (ordonnees)",1);
												break;
											
											case 2:
												PrintMini(4,18,"Le point M(x,y) a pour affixe",1);
												PrintMini(4,26,"z  = x + iy (ou m = x + iy)",1);
												PrintMini(9,28,"M",1);
												PrintMini(4,38,"L'affixe de u    est z = a + ib",1);
												ML_line(49,36,53,36,ML_BLACK);
												ML_line(51,35,51,38,ML_BLACK);
												parenthese(55,34,7);
												PrintMini(59,35,"a",1);
												PrintMini(59,43,"b",1);
												break;
												
											case 3:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
									
									case 7:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"Le point M' d'affixe z est le",1);
												ML_line(85,17,88,17,ML_BLACK);
												PrintMini(4,26,"symetrique de M d'affixe z",1);
												PrintMini(4,34,"par rapport a l'axe des reels",1);
												break;
											
											case 2:
												PrintMini(3,18,"Le point I est le milieu de [AB]",1);
												PrintMini(3,26,"et son affixe est :",1);
												PrintMini(5,38,"z =",1);
												ML_line(20,40,48,40,ML_BLACK);
												PrintMini(21,32,"z  + z",1);
												PrintMini(26,34,"A    B",1);
												PrintMini(33,42,"2",1);
												break;
											
											case 3:
												PrintMini(4,18,"Le vecteur AB a pour affixe",1);
												ML_line(48,16,57,16,ML_BLACK);
												ML_line(55,15,55,18,ML_BLACK);
												PrintMini(4,26,"z = z  - z",1);
												PrintMini(24,28,"B    A",1);
												PrintMini(4,34,"La distance entre A et B",1);
												PrintMini(4,42,"est : |z  - z",1);
												PrintMini(33,44,"B    A",1);
												PrintMini(57,42,"|",1);
												break;
											
											case 4:
												PrintMini(4,18,"La mediatrice de [AB] est",1);
												PrintMini(4,26,"l'ensemble des points M",1);
												PrintMini(4,34,"verifiant :",1);
												PrintMini(4,42,"|z  - z",1);
												PrintMini(10,44,"M",1);
												PrintMini(30,44,"A",1);
												PrintMini(34,42,"| = |z  - z",1);
												PrintMini(54,44,"M",1);
												PrintMini(74,44,"B",1);
												PrintMini(78,42,"|",1);
												break;
											
											case 5:
												PrintMini(4,18,"Le cercle de centre C et de",1);
												PrintMini(4,26,"rayon r > 0 est l'ensemble",1);
												PrintMini(4,34,"des points M verifiant :",1);
												PrintMini(4,42,"|z  - z",1);
												PrintMini(10,44,"M",1);
												PrintMini(30,44,"C",1);
												PrintMini(34,42,"| = r",1);
												break;
											
											case 6:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
								}
							}
							else
							{
								switch(choix)
								{
									case 1:		
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"Soient M un point et z son",1);
												PrintMini(4,26,"affixe : on appelle argument",1);
												PrintMini(4,34,"de z, note arg(z) la mesure de ",1);
												PrintMini(4,43,"l'angle (u,OM)",1);
												ML_line(39,41,43,41,ML_BLACK);
												ML_line(41,40,41,43,ML_BLACK);
												ML_line(47,41,55,41,ML_BLACK);
												ML_line(53,40,53,43,ML_BLACK);
												break;
											
											case 2:
												PrintMini(4,18,"Si",1);
												PrintMini(21,18,"designe un argument de z",1);
												theta(13,18);
												PrintMini(4,26,"alors :",1);
												PrintMini(4,38,"cos  =    et sin  =",1);
												theta(17,38);
												ML_line(30,40,37,40,ML_BLACK);
												PrintMini(32,33,"x",1);
												PrintMini(30,42,"|z|",1);
												theta(68,38);
												ML_line(81,40,88,40,ML_BLACK);
												PrintMini(83,33,"y",1);
												PrintMini(81,42,"|z|",1);
												break;
											
											case 3:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
										
									case 2:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"La forme trigonometrique de z",1);
												PrintMini(4,26,"est :",1);
												PrintMini(4,34,"z = |z| * (cos  + i * sin  )",1);
												theta(58,34);
												theta(101,34);
												break;
												
											case 2:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
									
									case 3:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"arg(-z) =   + arg(z)",1);
												pi(42,18);
												modulo_deux_pi(85,18);
												PrintMini(4,26,"arg(z) = -arg(z)",1);
												ML_line(20,25,23,25,ML_BLACK);
												modulo_deux_pi(69,26);
												PrintMini(4,34,"arg(zz') = arg(z) + arg(z')",1);
												modulo_deux_pi(110,34);
												PrintMini(4,42,"arg(z     n * arg(z)",1);
												PrintMini(24,40,"n",1);
												modulo_deux_pi(89,42);
												PrintMini(29,42,") =",1);
												break;
											
											case 2:
												PrintMini(4,21,"arg    = arg(z) - arg (z')",1);
												parenthese(18,15,7);
												modulo_deux_pi(110,21);
												PrintMini(22,16,"z",1);
												ML_line(21,23,27,23,ML_BLACK);
												PrintMini(21,25,"z'",1);
												break;
												
											case 3:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;	
										
									case 4:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,18,"La forme exponentielle de z",1);
												PrintMini(4,26,"est :",1);
												PrintMini(4,34,"z = |z| * e",1);
												PrintMini(46,32,"i",1);
												theta(48,32);
												PrintMini(4,42,"D'ou e   = cos  + i * sin",1);
												PrintMini(27,40,"i",1);
												theta(29,40);
												theta(60,42);
												theta(103,42);
												break;
												
											case 2:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;	
									
									case 5:
										switch(position_cours)
										{
											case 1:
												PrintMini(4,20,"(u,AB) = arg(z -z )",1);
												ML_line(7,17,11,17,ML_BLACK);
												ML_line(9,16,9,19,ML_BLACK);
												ML_line(14,17,21,17,ML_BLACK);
												ML_line(19,16,19,19,ML_BLACK);
												PrintMini(57,22,"B  A",1);
												modulo_deux_pi(79,20);
												PrintMini(4,37,"(AB,CD) = arg",1);
												ML_line(7,34,14,34,ML_BLACK);
												ML_line(12,33,12,36,ML_BLACK);
												ML_line(18,34,25,34,ML_BLACK);
												ML_line(23,33,23,36,ML_BLACK);
												parenthese(54,30,23);
												ML_line(57,38,77,38,ML_BLACK);
												PrintMini(58,30,"z -z",1);
												PrintMini(62,32,"D  C",1);
												PrintMini(58,40,"z -z",1);
												PrintMini(62,42,"B  A",1);
												modulo_deux_pi(85,37);
												break;
											
											case 2:
												PrintMini(4,18,"Si A, B et C sont aligne",1);
												PrintMini(4,26,"alors :",1);
												PrintMini(10,34,"z -z",1);
												PrintMini(14,36,"C  A",1);
												ML_line(10,42,30,42,ML_BLACK);
												PrintMini(10,44,"z -z",1);
												PrintMini(14,46,"B  A",1);
												PrintMini(34,40,"est un reel",1);
												break;
												
												
											case 3:
												PrintMini(4,18,"Si (AB) et (CD) sont paralleles",1);
												PrintMini(4,26,"alors :",1);
												PrintMini(10,34,"z -z",1);
												PrintMini(14,36,"D  C",1);
												ML_line(10,42,30,42,ML_BLACK);
												PrintMini(10,44,"z -z",1);
												PrintMini(14,46,"B  A",1);
												PrintMini(34,40,"est un reel",1);
												break;
												
											case 4:
												PrintMini(4,18,"Si (AB) et (CD) sont",1);
												PrintMini(4,26,"perpendiculaires alors :",1);
												PrintMini(10,34,"z -z",1);
												PrintMini(14,36,"D  C",1);
												ML_line(10,42,30,42,ML_BLACK);
												PrintMini(10,44,"z -z",1);
												PrintMini(14,46,"B  A",1);
												PrintMini(34,40,"est un imaginaire pur",1);
												break;
												
											case 5	:
												PrintMini(53,31,"Retour",1);
												break;
										}
										break;
								}
								
							}	
		
							affichage_cours = 0;
						}
					
						ML_display_vram();
					}
				
					clear();
			
					affichage_menu_cours(nombre_pages,choix);
					PrintXY(12,6,"Complexes : cours",1);
					
					affichage = 1;
					
					permission_quitter  = 0;
				}
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_choix_cours_complexe(1);
				affichage_complexe_choix_cours(choix_choix_cours);
			}
	
			ML_display_vram();
			
			permission_quitter = 0;				//Remise a 0 des variables
			maintien_fonction_choix_cours = 1;
			maintien_fonction_cours = 1;
			maintien_fonction = 1;
			affichage = 1;
			position = 1;
			position_cours = 1;
			affichage_cours = 1;
			choix = 1;
		}
	}
}

void complexes_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0, fleche = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour, fleche : si c'est egal a 1 : regarde s'il faut afficher ou non une fleche
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(10,6,"Complexes : quest.",1);
	
	question();
	
	case_question_complexes(2);
	case_question(1,2);

	fleche_question(milieu,8);
	
	affichage_question_complexes(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 9 && retour == 0)
		{
			choix ++;
			
			if(choix > (milieu + 1))
			{	
				milieu ++;
				fleche = 1;		
				case_question_complexes(milieu);
				
			}
			else
				case_question(choix - 1 , milieu);
			
			case_question(choix,milieu);	
			affichage_question_complexes(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			if(choix < (milieu - 1))
			{	
				milieu --;
				fleche = 1;
				case_question_complexes(milieu);
				case_question(choix,milieu);
			}
			else
			{
				case_question(choix + 1 , milieu);
				case_question(choix , milieu);
			}
	
			affichage_question_complexes(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(fleche)	//Affichage des fleches pour que l'utilisateur sache s'il y a des choix plus bas ou plus haut
		{
			fleche_question(milieu,8);
			fleche = 0;	
		}

		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			pages = 2;		//nombre de page predominante	
			
			switch(choix)
			{
				case 1:
					pages = 6;
					PrintMini(39,4,"Forme algebrique",1);
					break;
				case 2:
					PrintMini(39,4,"Module",1);
					break;
				case 3:
					PrintMini(39,4,"Argument",1);
					break;
				case 4:
					PrintMini(39,4,"Points invariants",1);
					break;
				case 5:
					pages = 5;
					PrintMini(39,4,"Ensemble",1);
					break;
				case 6:
					PrintMini(39,4,"Forme trigonometrique",1);
					break;
				case 7:
					PrintMini(39,4,"Forme exponentielle",1);
					break;
				case 8:
					PrintMini(39,4,"Cercle",1);
					break;
				case 9:
					PrintMini(39,4,"Figure",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <51 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"On appelle forme algebrique",1);
									PrintMini(4,22,"d'un complexe la forme :",1);
									PrintMini(4,30,"z = x + iy ou x et y sont des",1);
									PrintMini(4,38,"reels",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : Mettre z=(3+i)/(1+i)",1);
									PrintMini(4,22,"sous forme algebrique",1);
									PrintMini(4,35,"z =",1);
									ML_line(20,37,53,37,ML_BLACK);
									PrintMini(21,31,"(3+i)(1-i)",1);
									PrintMini(21,39,"(1+i)(1-i)",1);
									PrintMini(57,35,"=",1);
									ML_line(65,37,81,37,ML_BLACK);
									PrintMini(66,31,"4-2i",1);
									PrintMini(71,39,"2",1);
									PrintMini(85,35,"= 2 - i",1);
									break;
								
								case 3:
									PrintMini(4,14,"Si le complexe est sous forme",1);
									PrintMini(4,22,"trigonometrique : il faut",1);
									PrintMini(4,30,"developper son expression",1);
									break;
								
								case 4:
									PrintMini(3,14,"Exemple : z=2(cos",1);
									PrintMini(76,14,"/2+i*sin ",1);
									PrintMini(112,14,"/2)",1);
									pi(71,14);
									pi(107,14);
									PrintMini(3,22,"z = 2(0 + i) = 2i",1);
									break;
								
								case 5:
									PrintMini(4,14,"Si le complexe est sous forme",1);
									PrintMini(4,22,"exponentielle : il faut",1);
									PrintMini(4,30,"transformer son expression",1);
									PrintMini(4,38,"en forme trigonometrique",1);
									PrintMini(4,46,"puis la developper",1);
									break;
								
								case 6:
									PrintMini(4,15,"Exemple : z = 2e",1);
									PrintMini(69,13,"i",1);
									pi(71,13);
									PrintMini(76,13,"/2",1);
									PrintMini(4,23,"z=2(cos",1);
									PrintMini(39,23,"/2+i*sin ",1);
									PrintMini(75,23,"/2)",1);
									pi(34,23);
									pi(70,23);
									PrintMini(3,31,"z = 2(0 + i) = 2i",1);
									break;
								
								case 7:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour calculer le module d'un",1);
									PrintMini(4,22,"nombre complexe il faut que",1);
									PrintMini(4,30,"ce dernier soit sous sa forme",1);
									PrintMini(4,38,"algebrique et utiliser la",1);
									PrintMini(4,46,"formule (voir partie cours)",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : z = 3 + 4i",1);
									PrintMini(4,25,"|z| =           =  25 = 5",1);
									PrintMini(28,26,"3  + 4  ",1);
									racine_carre(22,22,31);
									PrintMini(32,24,"2    2",1);
									racine_carre(71,22,10);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour calculer l'argument d'un",1);
									PrintMini(4,22,"nombre complexe il faut que",1);
									PrintMini(4,30,"ce dernier soit sous sa forme",1);
									PrintMini(4,38,"algebrique et utiliser la",1);
									PrintMini(4,46,"formule (voir partie cours)",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : z =",1);
									PrintMini(62,15,"3 + i",1);
									racine_carre(57,13,6);
									PrintMini(4,26,"|z| =  3 + 1 = 2  arg(z) =",1);
									racine_carre(22,23,22);
									theta(105,26);
									PrintMini(4,34,"cos  =",1);
									theta(17,34);
									racine_carre(28,32,6);
									PrintMini(33,34,"3/2",1);
									PrintMini(4,42,"sin  = 1/2",1);
									theta(17,42);
									PrintMini(60,38,"D'ou  =",1);
									theta(77,38);
									ML_line(88,40,93,40,ML_BLACK);
									pi(88,34);
									PrintMini(89,42,"6",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 4:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour trouver les points",1);
									PrintMini(4,22,"invariants d'une application du",1);
									PrintMini(4,30,"type z' = (iz)/(z+1), il faut",1);
									PrintMini(4,38,"poser et resoudre l'equation",1);
									PrintMini(4,46,"z' = z",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : z' = 3z + 2",1);
									PrintMini(4,22,"Les points invariants verifient",1);
									PrintMini(4,30,"z' = z donc z = 3z + 2",1);
									PrintMini(4,38,"d'ou 2z = -2 : z = -1. Ainsi le",1);
									PrintMini(4,46,"point invariant est z = -1",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 5:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Il faut generalement trouver",1);
									PrintMini(4,22,"un ensemble de points en lien",1);
									PrintMini(4,30,"avec une application z' tel",1);
									PrintMini(4,38,"que z' soit un reel ou un",1);
									PrintMini(4,46,"un imaginaire pur",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple :",1);
									PrintMini(4,26,"z' =",1);
									ML_line(22,28,57,28,ML_BLACK);
									PrintMini(27,22,"5x-y+4",1);
									PrintMini(23,32,"x +(y-1)",1);
									PrintMini(27,30,"2",1);
									PrintMini(53,30,"2",1);
									PrintMini(61,26,"+",1);
									ML_line(69,28,114,28,ML_BLACK);
									PrintMini(70,22,"x +y +4x-4y",1);
									PrintMini(74,20,"2  2",1);
									PrintMini(74,32,"x +(y-1)",1);
									PrintMini(78,30,"2",1);
									PrintMini(104,30,"2",1);
									PrintMini(116,26,"i",1);
									PrintMini(4,42,"avec (x,y)   (0,1)",1);
									different(44,42);
									break;
								
								case 3:
									PrintMini(4,14,"z' est un imaginaire pur si :",1);
									ML_line(4,28,39,28,ML_BLACK);
									PrintMini(9,22,"5x-y+4",1);
									PrintMini(5,32,"x +(y-1)",1);
									PrintMini(9,30,"2",1);
									PrintMini(35,30,"2",1);
									PrintMini(43,26,"= 0    5x-y+4=0",1);
									equivaut(59,26);
									equivaut(59,34);
									PrintMini(71,34,"y=5x+4",1);
									PrintMini(4,42,"L'ensemble est une droite",1);
									break;
								
								case 4:
									PrintMini(4,14,"z' est un reel si :",1);
									ML_line(4,28,49,28,ML_BLACK);
									PrintMini(5,22,"x +y +4x-4y",1);
									PrintMini(9,20,"2  2",1);
									PrintMini(9,32,"x +(y-1)",1);
									PrintMini(13,30,"2",1);
									PrintMini(39,30,"2",1);
									PrintMini(53,26,"= 0",1);
									PrintMini(15,42,"x +y +4x-4y=0",1);
									PrintMini(19,40,"2  2",1);
									equivaut(4,42);
									break;
								
								case 5:
									equivaut(4,15);
									PrintMini(19,15,"(x+2) +(y-2) =8",1);
									PrintMini(37,13,"2",1);
									PrintMini(63,13,"2",1);
									equivaut(4,23);
									PrintMini(19,23,"[x-(-2)] +[y-(+2)] =(",1);
									PrintMini(47,21,"2",1);
									PrintMini(83,21,"2",1);
									racine_carre(94,21,6);
									PrintMini(99,23,"8",1);
									PrintMini(104,23,")",1);
									PrintMini(107,21,"2",1);
									PrintMini(4,31,"L'ensemble est un cercle de",1);
									PrintMini(4,39,"centre C(-2,2) et de rayon  8",1);
									racine_carre(112,37,6);
									break;
								
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 6:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"La forme trigonometrique de z",1);
									PrintMini(4,22,"tel que arg(z) =   est :",1);
									theta(70,22);
									PrintMini(4,30,"z = |z| * (cos  + i * sin  )",1);
									theta(58,30);
									theta(101,30);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : z =",1);
									PrintMini(62,15,"3 + i",1);
									racine_carre(57,13,6);
									PrintMini(4,26,"|z| =  3 + 1 = 2  arg(z) =",1);
									racine_carre(22,23,22);
									ML_line(105,28,110,28,ML_BLACK);
									pi(105,22);
									PrintMini(106,30,"6",1);
									PrintMini(4,38,"D'ou z = 2(cos  +i*sin  )",1);
									ML_line(59,40,64,40,ML_BLACK);
									pi(59,34);
									PrintMini(60,42,"6",1);
									ML_line(90,40,95,40,ML_BLACK);
									pi(90,34);
									PrintMini(91,42,"6",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 7:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"La forme exponentielle de z",1);
									PrintMini(4,22,"est :",1);
									PrintMini(4,30,"z = |z| * e",1);
									PrintMini(46,28,"i",1);
									theta(48,28);
									PrintMini(4,38,"Avec e   = cos  + i * sin",1);
									PrintMini(29,36,"i",1);
									theta(31,36);
									theta(62,38);
									theta(105,38);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : z =",1);
									PrintMini(62,15,"3 + i",1);
									racine_carre(57,13,6);
									PrintMini(4,26,"|z| =  3 + 1 = 2  arg(z) =",1);
									racine_carre(22,23,22);
									ML_line(105,28,110,28,ML_BLACK);
									pi(105,22);
									PrintMini(106,30,"6",1);
									PrintMini(4,42,"D'ou z = 2e",1);
									PrintMini(47,37,"i",1);
									ML_line(49,39,54,39,ML_BLACK);
									pi(49,33);
									PrintMini(50,41,"6",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 8:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour montrer que des points",1);
									PrintMini(4,22,"sont sur un meme cercle,",1);
									PrintMini(4,30,"il faut calculer la distance",1);
									PrintMini(4,38,"entre chaque points et le",1);
									PrintMini(4,46,"centre et les comparer",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : A(2,0), B(0,2),  ",1);
									PrintMini(4,22,"Montrer que A et B sont sur",1);
									PrintMini(4,30,"le cercle de centre O et de",1);
									PrintMini(4,38,"rayon 2. OC=|c|=2  OA=|a|=2",1);
									PrintMini(4,46,"OA=OC donc c'est est vrai",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 9:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour montrer que des points",1);
									PrintMini(4,22,"forment une figure, il faut",1);
									PrintMini(4,30,"calculer les distances et/ou",1);
									PrintMini(4,38,"les angles et arriver a une",1);
									PrintMini(4,46,"conclusion",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : A(2,0), B(0,2),  ",1);
									PrintMini(4,22,"Montrer que OAB est un",1);
									PrintMini(4,30,"triangle isocele :",1);
									PrintMini(4,38,"On a OA = OB donc OAB",1);
									PrintMini(4,46,"est isocele en O",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
				PrintXY(10,6,"Complexes : quest.",1);
	
				question();
				fleche = 1;
				case_question_complexes(milieu);
				case_question(choix,milieu);
				affichage_question_complexes(choix);	
				fleche_question(milieu,4);
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_complexes(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	if(milieu == 2)PrintMini(9,26,"Algebriq.",0);
	if(milieu > 1 && milieu < 4)PrintMini(13,62 - 12*milieu, "Module", 0);
	if(milieu > 1 && milieu < 5)PrintMini(8,74 - 12*milieu, "Argument", 0);
	if(milieu > 2 && milieu < 6)PrintMini(7,86 - 12*milieu, "Invariant", 0);
	if(milieu > 3 && milieu < 7)PrintMini(8,98 - 12*milieu, "Ensemble", 0);
	if(milieu > 4 && milieu < 8)PrintMini(15,110 - 12*milieu, "Trigo.", 0);
	if(milieu > 5 && milieu < 9)PrintMini(17,122 - 12*milieu, "Expo.", 0);
	if(milieu > 6 && milieu < 10)PrintMini(13,134 - 12*milieu, "Cercle", 0);
	if(milieu == 8)PrintMini(14,146 - 12*milieu, "Figure", 0);
}

void affichage_question_complexes(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"la forme",0);
			PrintMini(54,38,"algebrique",0);
			PrintMini(54,44,"d'un",0);
			PrintMini(54,50,"complexe",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Calculer le",0);
			PrintMini(54,32,"module d'un",0);
			PrintMini(54,38,"complexe",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Calculer",0);
			PrintMini(54,32,"l'argument",0);
			PrintMini(54,38,"d'un",0);
			PrintMini(54,44,"complexe",0);
			break;
	
		case 4 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"les points",0);
			PrintMini(54,38,"invariants",0);
			PrintMini(54,44,"d'une",0);
			PrintMini(54,50,"application",0);
			break;
			
		case 5 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"un ensemble",0);
			PrintMini(54,38,"de points",0);
			break;
			
		case 6 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"la forme",0);
			PrintMini(54,38,"trigo. d'un",0);
			PrintMini(54,44,"complexe",0);
			break;
			
		case 7 :
			PrintMini(54,26,"Determiner",0);
			PrintMini(54,32,"la forme",0);
			PrintMini(54,38,"expo. d'un",0);
			PrintMini(54,44,"complexe",0);
			break;
			
		case 8 :
			PrintMini(54,26,"Prouver que",0);
			PrintMini(54,32,"plusieurs",0);
			PrintMini(54,38,"points sont",0);
			PrintMini(54,44,"sur un meme",0);
			PrintMini(54,50,"cercle",0);
			break;
			
		case 9 :
			PrintMini(54,26,"Prouver que",0);
			PrintMini(54,32,"plusieurs",0);
			PrintMini(54,38,"points",0);
			PrintMini(54,44,"forment une",0);
			PrintMini(54,50,"figure",0);
			break;
	}
	
}