#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void ln()		
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	
	
	PrintXY(6,6,"Logarithme neperien",1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				ln_cours();
	
			if(choix == 2)
				ln_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(6,6,"Logarithme neperien",1);
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	
	}
}

void ln_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(5,1);
	
	PrintXY(30,6,"ln : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 5  && position == 1)
		{
			choix += 1;
			choix_cours(choix,5);
			choix_cours(choix-1,5);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,5);
			choix_cours(choix+1,5);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,5);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,5);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(46,34,"Definition",0);
						break;
					case 2:
						PrintMini(47,34,"Formules",0);
						break;
					case 3:
						PrintMini(24,34,"Etude des variations",0);
						break;
					case 4:
						PrintMini(11,34,"Limites logarithme neperien",0);
						break;
					case 5:
						PrintMini(45,34,"Derivation",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 1;		//Nombre de pages predominant
			
			switch(choix)		//Affichage nom de la partie et determination du nombre de pages
			{
				case 1:
					PrintMini(46,4,"Definition",0);
					break;
				case 2:
					pages = 3;
					PrintMini(47,4,"Formules",0);
					break;
				case 3:
					PrintMini(24,4,"Etude des variations",0);
					break;
				case 4:
					pages = 2;
					PrintMini(45,4,"Limites ln",1);	
					break;
				case 5:
					PrintMini(45,4,"Derivation",0);
					break;
			}
			
			if(choix == 3)		//Affichage des deux bandes noires
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,11+116*j,i,ML_BLACK);
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 16 ; i <50 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(2,18,"La fonction logarithme neperien",1);
									PrintMini(2,26,"est note ln(x). Elle est definie",1);	
									PrintMini(2,34,"sur ] 0 , +   [ et a valeurs",1);
									infini(46,35);
									PrintMini(2,42,"dans |R",1);
									break;
								
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Formules admises :",1);
									PrintMini(4,26,"ln(1) = 0",1);
									PrintMini(4,34,"ln(e  ) = a",1);
									PrintMini(21,32,"a",1);
									PrintMini(4,42,"ln(a * b) = ln(a) + ln(b)",1);
									break;
								
								case 2:
									PrintMini(4,18,"ln(1 / b) = - ln(b)",1);
									PrintMini(4,26,"ln(a / b) = ln(a) - ln(b)",1);
									PrintMini(4,34,"ln(a  ) = n * ln(a)",1);
									PrintMini(21,32,"n",1);
									break;
									
								case 3:
									PrintMini(4,18,"Equation :",1);
									PrintMini(4,26,"ln(a) = ln(b)     a = b",1);
									equivaut(59,26);
									PrintMini(4,34,"ln(a) = b    a = e",1);
									PrintMini(76,32,"b",1);
									equivaut(42,34);
									PrintMini(4,42,"De meme pour les inequations",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(2,18,"La fonction logarithme neperien",1);
									PrintMini(2,26,"strictement croissante sur son",1);
									PrintMini(2,34,"domaine de definition. Pour",1);
									PrintMini(2,42,"tout x > 1 , ln(x) > 0 ",1);
									break;
								
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									affichage_limite(4,18,100,0);
									PrintMini(20,18,"ln(x) = +",1);
									infini(56,19);
									affichage_limite(4,32,0,1);
									PrintMini(20,32,"ln(x) = -",1);
									infini(56,33);
									break;
								
								case 2:
									affichage_limite(4,19,100,0);
									PrintMini(34,18,"ln(x)",1);
									ML_line(33,24,51,24,ML_BLACK);
									PrintMini(40,26,"x",1);
									PrintMini(55,22,"= 0",1);
									affichage_limite(4,33,0,1	);
									PrintMini(20,33,"xln(x) = 0",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Soit u derivable sur I : avec",1);
									PrintMini(4,26,"pour tout x sur I : u(x) > 0",1);
									PrintMini(4,34,"ln(u(x)) est derivable sur I",1);
									PrintMini(4,42,"avec (ln(u(x)))' = u'(x) / u(x)",1);
									break;
								
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(5,choix);
				PrintXY(30,6,"ln : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void ln_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(21,6,"ln : questions",1);
	
	question();
	
	case_question_ln(2);
	case_question(1,2);
	
	affichage_question_ln(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 3 && retour == 0)
		{
			choix ++;
			
			case_question(choix - 1 , milieu);
			case_question(choix,milieu);	
			affichage_question_ln(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			case_question(choix + 1 , milieu);
			case_question(choix , milieu);
			affichage_question_ln(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			switch(choix)
			{
				case 1:
					pages = 4;
					PrintMini(39,4,"Equation ln",1);
					break;
				case 2:
					pages = 2;
					PrintMini(39,4,"Derive ln",1);
					break;
				case 3:
					pages = 2;
					PrintMini(39,4,"Variation ln",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <51 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour resoudre une equation",1);
									PrintMini(4,22,"de type ln(a) = ln(b), il faut",1);
									PrintMini(4,30,"poser a = b et trouver les",1);
									PrintMini(4,38,"reponses (De meme pour les",1);
									PrintMini(4,46,"inequations)",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : ln(-3x+5) = ln(x)",1);
									equivaut(4,23);
									PrintMini(17,23,"-3x + 5 = x",1);
									equivaut(4,31);
									PrintMini(17,31,"4x = 5",1);
									equivaut(4,39);
									PrintMini(17,39,"x = (5/4)",1);
									break;
								
								case 3:
									PrintMini(4,14,"Pour resoudre une equation",1);
									PrintMini(4,22,"de type ln(a) = b, il faut ",1);
									PrintMini(4,30,"poser a = e  et trouver les ",1);
									PrintMini(49,28,"b",1);
									PrintMini(4,38,"reponses (De meme pour",1);
									PrintMini(4,46,"les inequations)",1);
									break;
								
								case 4:
									PrintMini(4,15,"Exemple : ln(3x+5) = 2",1);
									equivaut(4,24);
									PrintMini(17,24,"3x + 5 = e",1);
									PrintMini(57,22,"2",1);
									equivaut(4,33);
									PrintMini(17,33,"3x = e  - 5",1);
									PrintMini(41,31,"2",1);
									equivaut(4,42);
									PrintMini(17,42,"x = [e  - 5]/3",1);
									PrintMini(40,39,"2",1);
									break;
				
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Soit u derivable sur I : avec",1);
									PrintMini(4,22,"pour tout x sur I : u(x) > 0",1);
									PrintMini(4,30,"ln(u(x)) est derivable sur I",1);
									PrintMini(4,38,"avec (ln(u(x)))' = u'(x) / u(x)",1);
									break;
									
								case 2:
									PrintMini(4,15,"Exemple : f(x) = ln(3x+5)",1);
									PrintMini(4,23,"On a u(x) = 3x + 5 : u'(x) = 3",1);
									PrintMini(4,32,"D'ou f'(x) = (3)/(3x+5)",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"La fonction ln est strictement",1);
									PrintMini(4,22,"croissante sur son domaine",1);
									PrintMini(4,30,"definition (pour tout x > 0)",1);
									PrintMini(4,38,"Pour tout x > 1 : ln(x) > 0",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : f(x) = ln(1/2)x",1);
									PrintMini(4,22,"0 < 1/2 < 1, donc ln(1/2) < 0",1);
									PrintMini(4,30,"Donc f(x) est strictement",1);
									PrintMini(4,38,"decroissante sur |R",1);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(21,6,"ln : questions",1);
		
				question();
				
				case_question_ln(milieu);
				case_question(choix,milieu);
				affichage_question_ln(choix);	
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_ln(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	PrintMini(10,26,"Equation",0);
	PrintMini(14,38, "Derive", 0);
	PrintMini(8,50, "Variation", 0);
}

void affichage_question_ln(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Resoudre une",0);
			PrintMini(54,32,"equation",0);
			PrintMini(54,38,"impliquant",0);
			PrintMini(54,44,"des ln",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Trouver la",0);
			PrintMini(54,32,"derive d'une",0);
			PrintMini(54,38,"fonction",0);
			PrintMini(54,44,"impliquant",0);
			PrintMini(54,50,"des ln",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Trouver les",0);
			PrintMini(54,32,"variations",0);
			PrintMini(54,38,"d'une",0);
			PrintMini(54,44,"fonction ln",1);
			break;
	}
	
}
