#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "mathsTS.h"
#include "affichage_chapitre.h"
#include "affichage_cours.h"
#include "affichage_question.h"
#include "affichage_signes.h"
#include "cours.h"

void suite()		//chapitre sur les suites
{
	int i = 0 , choix = 1 , permission_quitter = 0, maintien_fonction = 1;		//Permission de quitter : permission d'appuyer sur exe ou exit pour quitter, ou rentrer dans une section
	
	clear();

	menu_cours(choix);	//Affichage du menu des suites
	
	PrintXY(45,6,"Suites",1);	
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))	//L'utilisateur doit arreter d'appuyer sur "exe" et "exit" pour refaire un choix
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 3)
		{
			choix += 1;
			affichage_menu(choix);
			affichage_menu(choix-1);
			ML_display_vram();
		
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1)
		{
			choix -= 1;
			affichage_menu(choix);
			affichage_menu(choix+1);
			ML_display_vram();
		
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_EXE) && choix < 3 && permission_quitter)
		{
			if(choix == 1)
				suite_cours();
	
			if(choix == 2)
				suite_question();
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				menu_cours(choix);
				PrintXY(45,6,"Suites",1);	
			}

			permission_quitter = 0;

			ML_display_vram();

		}

		if((IsKeyDown(KEY_CTRL_EXE) == 1 && choix == 3 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
		{
			maintien_fonction = 0;
			
			timer();
		}	

	}

	
}

void suite_cours()
{
	int i = 0, j = 0, permission_quitter = 0;
	int position = 1, maintien_fonction = 1, affichage = 1, choix = 1; 	//Variables pour le menu
	int maintien_fonction_cours = 1, position_cours = 1, pages = 0, affichage_cours = 1;		//Variables pour l'affichage du cours
	
	clear();
	
	affichage_menu_cours(9,1);
	
	PrintXY(20,6,"Suites : cours",1);

	while(maintien_fonction)
	{	
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyDown(KEY_CTRL_RIGHT) && choix != 9  && position == 1)
		{
			choix += 1;
			choix_cours(choix,9);
			choix_cours(choix-1,9);
			affichage = 1;
			
			timer();
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && choix != 1  && position == 1)
		{
			choix -= 1;
			choix_cours(choix,9);
			choix_cours(choix+1,9);
			affichage = 1;
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_DOWN) && position == 1)
		{
			position = 2;
			affichage = 1;
			retour_cours();
			choix_cours(choix,9);
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && position == 2)
		{
			position = 1;
			affichage = 1;
			retour_cours();
			choix_cours(choix,9);
		}
		
		if((IsKeyDown(KEY_CTRL_EXE) && position == 2 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(affichage == 1)
		{
			for(i = 34 ; i < 40 ; i++)ML_line(1,i,127,i,ML_WHITE);	//Effaage du texte 
					
			if(position == 1)		// Affichage du titre de la section
			{
				switch(choix)
				{
					case 1:
						PrintMini(25,34,"Suites arithmetiques",0);
						break;
					case 2:
						PrintMini(25,34,"Suites geometriques",0);
						break;
					case 3:
						PrintMini(31,34,"Suites monotones",0);
						break;
					case 4:
						PrintMini(9,34,"majoree / minoree / bornee",0);
						break;
					case 5:
						PrintMini(33,34,"Limites de suites",0);
						break;
					case 6:
						PrintMini(41,34,"Convergence",0);
						break;
					case 7:
						PrintMini(16,34,"Theoreme des gendarmes",0);
						break;
					case 8:
						PrintMini(16,34,"Theoreme de comparaison",0);
						break;
					case 9:
						PrintMini(7,34,"Raisonnement par recurrence",0);
						break;
				}
			}
		
			if(position == 2)PrintMini(35,34,"Retour au menu",0);
			
			affichage = 0;

		}

		ML_display_vram();
		
		if(IsKeyDown(KEY_CTRL_EXE) && position == 1 && permission_quitter)		//Appel des sous programmes pour le cours
		{
			clear();
			
			pages = 3;		//Nombre de pages predominant
			
			switch(choix)		//Affichage nom de la partie et determination du nombre de pages
			{
				case 1: 
					PrintMini(26,4,"Suites arithmetiques",1);
					break;
				case 2:
					PrintMini(26,4,"Suites geometriques",1);	
					break;
				case 3:
					pages = 5;
					PrintMini(30,4,"Suites monotones",1);
					break;
				case 4:
					PrintMini(27,4,"Majoree / Minoree",1);
					break;
				case 5:
					PrintMini(32,4,"Limites de suites",1);	
					break;
				case 6:
					pages = 4;
					PrintMini(41,4,"Convergence",1);
					break;
				case 7:
					pages = 1;
					PrintMini(16,4,"Theoreme des gendarmes",1);	
					break;
				case 8:
					pages = 2;
					PrintMini(16,4,"Theoreme de comparaison",1);	
					break;
				case 9:
					pages = 4;
					PrintMini(43,4,"Recurrence",1);
					break;
			}
			
			if(choix < 7 || choix == 9)
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+108*j,i,18+110*j,i,ML_BLACK);	//Affichage des deux bandes noires
			else
				for(j = 0 ; j < 2 ; j++)for(i = 1 ; i < 12 ; i++)ML_line(1+116*j,i,11+116*j,i,ML_BLACK);
			
			bouton_retour_cours();		//Affichage graphisme
			cours_pixel(pages);
			choix_page(1,pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_cours = 1;
			maintien_fonction_cours = 1;
			affichage_cours = 1;
			
			while(maintien_fonction_cours)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_cours = 0;
				
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_cours != pages + 1)
				{
					position_cours += 1;
					affichage_cours = 1;
			
					if(position_cours<pages+1)
						choix_page(position_cours,pages);
					else
						affichage_bouton_retour_cours();
			
					choix_page(position_cours-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_cours != 1)
				{
					position_cours -= 1;
					affichage_cours = 1;
			
					choix_page(position_cours,pages);
			
					if(position_cours<pages)
						choix_page(position_cours+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_cours == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_cours = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;
	
				if(IsKeyDown(KEY_CTRL_EXE) && position_cours != pages+1)permission_quitter  = 0;
			
				if(affichage_cours)
				{
					for(i = 16 ; i <50 ; i++)ML_line(2,i,127,i,ML_WHITE);
		
					switch(choix)
					{
						case 1:		
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Une suite arithmetique est",1);
									PrintMini(4,26,"de la forme :",1);
									PrintMini(38,36,"U    = U  + r",1);
									PrintMini(38,39," n+1    n",1);
									break;
									
								case 2:
									PrintMini(4,18,"Up est le premier terme de Un",1);
									PrintMini(4,26,"r est la raison (un reel)",1);
									PrintMini(25,36,"U  = U  + (n-p) x r",1);
									PrintMini(25,39," n    p",1);
									break;
									
								case 3:
									PrintMini(4,18,"La somme Sn de Un est :",1);
									PrintMini(7,33,"Sn = (n - p + 1) x",1);
									ML_line(83,36,118,36,ML_BLACK);
									PrintMini(83,30,"(Un + Up)",1);
									PrintMini(99,39,"2",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 2:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Une suite geometrique est",1);
									PrintMini(4,26,"de la forme :",1);
									PrintMini(38,36,"V    = V  x q",1);
									PrintMini(38,39," n+1    n",1);
									break;
								
								case 2:
									PrintMini(4,18,"Vp est le premier terme de Vn",1);
									PrintMini(4,26,"q est la raison (un reel)",1);
									PrintMini(34,39,"V  = V  x q",1);
									PrintMini(34,42," n    p",1);
									PrintMini(36,36,"           n-p",1);
									break;
									
								case 3:
									PrintMini(4,18,"La somme Sn de Vn est :",1);
									PrintMini(22,33,"Sn = V  x",1);
									PrintMini(24,36,"      p",1);
									ML_line(62,36,105,36,ML_BLACK);
									PrintMini(62,30,"1 - q",1);
									PrintMini(84,26,"n-p+1",1);
									PrintMini(73,39,"1 - q",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 3:
							switch(position_cours)
							{
								case 1:
									PrintMini(2,18,"La suite (Un) est monotone",1);
									PrintMini(2,26,"(respectivement strictement)",1);
									PrintMini(2,34,"si elle est croissante ou ",1);
									PrintMini(2,42,"decroissante (resp strictement)",1);
									break;
								
								case 2:
									PrintMini(4,18,"Etude des variations de (Un) :",1);
									PrintMini(4,26,"Calculer Un+1 - Un",1);
									PrintMini(4,34,"(Un) est croissante si c'est >0",1);
									PrintMini(4,42,"(Un) est decroissante sinon",1);
									break;
									
								case 3:
									PrintMini(4,18,"Etude des variations de (Un) :",1);
									PrintMini(4,26,"Calculer Un+1 / Un ",1);
									PrintMini(4,34,"(Un) est croissante si c'est >1",1);
									PrintMini(4,42,"(Un) est decroissante sinon",1);
									break;
							
								case 4:
									PrintMini(4,18,"Si (Un) est de la forme",1);
									PrintMini(4,26,"Un = f(n) , il faut etudier",1);
									PrintMini(4,34,"les variations de f",1);
									break;
								
								case 5:
									PrintMini(4,18,"Si Un+1 = f(Un), il faut alors",1);
									PrintMini(4,26,"faire un raisonnement par",1);
									PrintMini(4,34,"par recurrence",1);
									break;
									
								case 6:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
							
						case 4:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"(Un) est majoree s'il existe M",1);
									PrintMini(4,26,"tel que pour tout n : Un   M",1);
									signe_inferieur_egal(105,26);
									PrintMini(4,34,"Toute suite decroissante est",1);
									PrintMini(4,42,"majoree par son 1er terme",1);
									break;
								
								case 2:
									PrintMini(4,18,"(Un) est minoree s'il existe m",1);
									PrintMini(4,26,"tel que pour tout n : Un   m",1);
									signe_superieur_egal(105,26);
									PrintMini(4,34,"Toute suite croissante est",1);
									PrintMini(4,42,"minoree par son 1er terme",1);
									break;
									
								case 3:
									PrintMini(4,18,"(Un) est bornee si elle est a",1);
									PrintMini(4,26,"la fois majoree et minoree",1);
									PrintMini(4,34,"Donc s'il existe m et M tel que",1);
									PrintMini(41,42,"m   Un   M",1);
									signe_inferieur_egal(50,42);
									signe_inferieur_egal(72,42);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;	
						
						case 5:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"(Un) admet l (un reel) comme",1);
									PrintMini(4,26,"limite si ] a , b [ (des reels)",1);
									PrintMini(4,34,"contient tous les termes de",1);
									PrintMini(4,42,"(Un) a partir d'un rang n0",1);
									break;
								
								case 2:
									PrintMini(4,18,"(Un) tend vers +    si Un",1);
									infini(71,19);
									PrintMini(4,26,"appartient a ] A , +   [",1);
									infini(83,27);
									PrintMini(4,34,"(A > 0) a partir d'un certain",1);
									PrintMini(4,42,"rang n0",1);
									break;
									
								case 3:
									PrintMini(4,18,"(Un) tend vers -    si Un",1);
									infini(71,19);
									PrintMini(4,26,"appartient a ] -    , A [",1);
									infini(69,27);
									PrintMini(4,34,"(A < 0) a partir d'un certain",1);
									PrintMini(4,42,"rang n0",1);
									break;
									
								case 4:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 6:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"(Un) est convergente si elle",1);
									PrintMini(4,26,"admet une limite reelle l",1);
									PrintMini(4,34,"(Un) est divergente si elle a",1);
									PrintMini(4,42,"pour limites : +    , -    , 0",1);
									infini(67,43);
									infini(94,43);
									ML_line(114,46,121,41,ML_BLACK);
									break;
								
								case 2:
									PrintMini(4,18,"Croissante et majoree :",1);
									PrintMini(4,26,"(Un) est convergente",1);
									PrintMini(4,34,"Croissante et non majoree :",1);
									PrintMini(4,42,"(Un) tend vers + ",1);
									infini(70,43);
									break;
									
								case 3:
									PrintMini(4,18,"Decroissante et minoree :",1);
									PrintMini(4,26,"(Un) est convergente",1);
									PrintMini(4,34,"Decroissante et non minoree :",1);
									PrintMini(4,42,"(Un) tend vers - ",1);
									infini(70,43);
									break;
								
								case 4:
									PrintMini(4,18,"Croissante et tend vers l :",1);
									PrintMini(4,26,"(Un) est majoree par l",1);
									PrintMini(4,34,"Decroissante et tend vers l :",1);
									PrintMini(4,42,"(Un) est minoree par l",1);
									break;
									
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 7:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Si pour tout n   p on a",1);
									signe_superieur_egal(63,18);
									PrintMini(4,26,"Un   Vn   Wn , et Un et Wn",1);
									signe_inferieur_egal(16,26);
									signe_inferieur_egal(37,26);
									PrintMini(4,34,"tendent vers l, alors Vn",1);
									PrintMini(4,42,"converge vers l (un reel)",1);
									break;
									
								case 2:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 8:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Si pour tout n   p on a",1);
									signe_superieur_egal(63,18);
									PrintMini(4,26,"Un   Wn et Wn tend vers +",1);
									signe_superieur_egal(16,26);
									infini(115,27);
									PrintMini(4,34,"alors Un tend vers +",1);
									infini(90,35);
									break;
								
								case 2:
									PrintMini(4,18,"Si pour tout n   p on a",1);
									signe_superieur_egal(63,18);
									PrintMini(4,26,"Un   Wn et Wn tend vers -",1);
									signe_inferieur_egal(16,26);
									infini(115,27);
									PrintMini(4,34,"alors Un tend vers -",1);
									infini(90,35);
									break;
									
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 9:
							switch(position_cours)
							{
								case 1:
									PrintMini(4,18,"Forme d'un raisonnement",1);
									PrintMini(4,26,"par recurrence : ",1);
									PrintMini(4,34,"On appelle Pn la propriete",1);
									PrintMini(4,42,"a demontrer",1);
									break;
								
								case 2:
									PrintMini(4,18,"Initialisation :",1);
									PrintMini(4,26,"Verifier que Pn0 est vraie",1);
									break;
									
								case 3:
									PrintMini(4,18,"Heredite :",1);
									PrintMini(4,26,"Montrer que si Pn est vrai ",1);
									PrintMini(4,34,"(pour un certain n   n0) :",1);
									PrintMini(4,42,"Pn+1 est vraie",1);
									signe_superieur_egal(81,34);
									break;
								
								case 4:
									PrintMini(4,18,"Conclusion :",1);
									PrintMini(4,26,"Conclure en disant que Pn est",1);
									PrintMini(4,34,"vraie pour tout n   n0",1);
									signe_superieur_egal(76,34);
									break;
									
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
					}

					affichage_cours = 0;
				}
			
				ML_display_vram();
			}
		
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				affichage_menu_cours(9,choix);
				PrintXY(20,6,"Suites : cours",1);
			}
			
			affichage = 1;
			
			permission_quitter  = 0;
		}
	}	
}

void suite_question()
{
	int i = 0, maintien_fonction = 1, permission_quitter = 0 , milieu = 2 , choix = 1, retour = 0, fleche = 0;	//milieu : numero de la case du milieu , choix : choix ou se trouve l'utilisateur, retour : si l'utilisateur se trouve sur le bouton retour, fleche : si c'est egal a 1 : regarde s'il faut afficher ou non une fleche
	int maintien_fonction_question = 1, position_question = 1, pages = 0, affichage_questions = 1;	
	
	clear();
	
	for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
	
	PrintXY(10,6,"Suites : questions",1);
	
	question();
	
	case_question_suite(2);
	case_question(1,2);

	fleche_question(milieu,4);
	
	affichage_question_suite(1);
	
	ML_display_vram();
	
	while(maintien_fonction)
	{
		if(IsKeyDown(KEY_CTRL_F6))
			maintien_fonction = 0;
		
		if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))
			permission_quitter = 1;
		
		if(IsKeyDown(KEY_CTRL_DOWN) && choix < 5 && retour == 0)
		{
			choix ++;
			
			if(choix > (milieu + 1))
			{	
				milieu ++;
				fleche = 1;		
				case_question_suite(milieu);
				
			}
			else
				case_question(choix - 1 , milieu);
			
			case_question(choix,milieu);	
			affichage_question_suite(choix);
			
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_UP) && choix > 1 && retour == 0)
		{
			choix --;
			
			if(choix < (milieu - 1))
			{	
				milieu --;
				fleche = 1;
				case_question_suite(milieu);
				case_question(choix,milieu);
			}
			else
			{
				case_question(choix + 1 , milieu);
				case_question(choix , milieu);
			}
	
			affichage_question_suite(choix);		
	
			timer();
		}
	
		if(IsKeyDown(KEY_CTRL_RIGHT) && retour == 0)
		{
			retour = 1;		
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en negatif
			case_question(choix , milieu);
		}
		
		if(IsKeyDown(KEY_CTRL_LEFT) && retour == 1)
		{
			retour = 0;
			for(i = 0 ; i < 9 ; i++)ML_line(111,51+i,124,51+i,ML_XOR);	//Affichage de la fleche en normal
			case_question(choix , milieu);
		}
	
		if((IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 1) || (permission_quitter && IsKeyDown(KEY_CTRL_EXIT)))		//Pour quitter la partie
			maintien_fonction = 0;	
		
		if(fleche)	//Affichage des fleches pour que l'utilisateur sache s'il y a des choix plus bas ou plus haut
		{
			fleche_question(milieu,4);
			fleche = 0;	
		}

		if(IsKeyDown(KEY_CTRL_EXE) && permission_quitter && retour == 0)
		{
			clear();
			
			pages = 4;		//Pour les questions 2 a 5	
			
			switch(choix)
			{
				case 1:
					pages = 2;
					PrintMini(39,4,"Termes de la suite Un",1);
					break;
				case 2:
					PrintMini(39,4,"Suite arithmetique",1);
					break;
				case 3:
					PrintMini(39,4,"Suite geometrique",1);
					break;
				case 4:
					PrintMini(39,4,"Variations de la suite",1);
					break;
				case 5:
					PrintMini(39,4,"Variations de la suite",1);
					break;
			}
			
			affichage_question(pages);
			
			permission_quitter = 0;		//Remise a 0 des variables
			position_question = 1;
			maintien_fonction_question = 1;
			affichage_questions = 1;
			
			while(maintien_fonction_question)
			{
				if(IsKeyDown(KEY_CTRL_F6))
					maintien_fonction_question = 0;
					
				if(IsKeyDown(KEY_CTRL_RIGHT) && position_question != pages+1)
				{
					position_question += 1;
					affichage_questions = 1;
			
					if(position_question < pages+1)
						choix_page(position_question,pages);
					else
						affichage_bouton_retour_cours();
				
					choix_page(position_question-1,pages);

					timer();
				}
		
				if(IsKeyDown(KEY_CTRL_LEFT) && position_question != 1)
				{
					position_question -= 1;
					affichage_questions = 1;
			
					choix_page(position_question,pages);
			
					if(position_question < pages)
						choix_page(position_question+1,pages);
					else
						affichage_bouton_retour_cours();
			
					timer();
				}
	
				if((IsKeyDown(KEY_CTRL_EXE) && position_question == pages+1 && permission_quitter) || IsKeyDown(KEY_CTRL_EXIT) && permission_quitter)
					maintien_fonction_question = 0;
	
				if(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT))permission_quitter = 1;

				if(IsKeyDown(KEY_CTRL_EXE) && position_question != pages+1)permission_quitter = 0;
			
				if(affichage_questions)
				{
					for(i = 13 ; i <51 ; i++)ML_line(2,i,126,i,ML_WHITE);
					
					switch(choix)
					{
						case 1:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour calculer les premiers",1);
									PrintMini(4,22,"termes d'une suite, il faut se",1);
									PrintMini(4,30,"referer a l'expression de la",1);
									PrintMini(3,38,"suite et a son premier terme",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : U    = U  + 2n + 2",1);
									PrintMini(49,16,"n+1    n",1);
									PrintMini(4,23,"et U  = 0. Calculer U et U  :",1);
									PrintMini(20,25,"0",1);
									PrintMini(88,25,"1",1);
									PrintMini(109,25,"2",1);
									PrintMini(4,32,"U = U  + 2*0 + 2 = 2",1);
									PrintMini(7,34,"1",1);
									PrintMini(24,34,"0",1);
									PrintMini(4,41,"U = U  + 2*1 + 2 = 6",1);
									PrintMini(8,43,"2",1);
									PrintMini(24,43,"1",1);
									break;
								
								case 3:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
						
						case 2:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour demontrer qu'une suite",1);
									PrintMini(4,23,"est arithmetique il faut",1);
									PrintMini(4,32,"calculer U    - Un et montrer",1);
									PrintMini(45,34,"n+1",1);
									PrintMini(4,41,"que c'est egal a une constante",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : U    = Un + 3",1);
									PrintMini(49,16,"n+1",1);
									PrintMini(4,23,"U    - Un = Un + 3 - Un = 3",1);
									PrintMini(9,25,"n+1",1);
									PrintMini(4,32,"Donc Un est une suite ",1);
									PrintMini(4,41,"arithmetique de raison 3",1);
									break;
								
								case 3:
									PrintMini(4,14,"Pour exprimer une suite",1);
									PrintMini(4,22,"arithmetique selon n il faut",1);
									PrintMini(4,30,"connaitre son premier terme",1);
									PrintMini(4,38,"(Up) et sa raison (r) :",1);
									PrintMini(4,46,"Un = Up + r * (n - p)",1);
									break;
								
								case 4:
									PrintMini(4,14,"Exemple : La suite Un est",1);
									PrintMini(4,22,"une suite arithmetique avec",1);
									PrintMini(4,30,"U  = 2 et r = 5",1);
									PrintMini(8,32,"0",1);
									PrintMini(4,38,"Un = U  + r(n-0) = 2 + 5n",1);
									PrintMini(29,40,"0",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 3:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"Pour demontrer qu'une suite",1);
									PrintMini(4,23,"est geometrique il faut",1);
									PrintMini(4,32,"calculer V    / Vn et montrer",1);
									PrintMini(45,34,"n+1",1);
									PrintMini(4,41,"que c'est egal a une constante",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : V    = 3*Vn",1);
									PrintMini(49,16,"n+1",1);
									PrintMini(4,23,"V    / Vn = (3 *Vn)/Vn = 3",1);
									PrintMini(9,25,"n+1",1);
									PrintMini(4,32,"Donc Vn est une suite ",1);
									PrintMini(4,41,"geometrique de raison 3",1);
									break;
								
								case 3:
									PrintMini(4,14,"Pour exprimer une suite",1);
									PrintMini(4,22,"geometrique selon n il faut",1);
									PrintMini(4,30,"connaitre son premier terme",1);
									PrintMini(4,38,"(Vp) et sa raison (q) :",1);
									PrintMini(4,46,"Vn = Vp * q",1);
									PrintMini(52,44,"n-p",1);
									break;
								
								case 4:
									PrintMini(4,14,"Exemple : La suite Vn est",1);
									PrintMini(4,22,"une suite geometrique avec",1);
									PrintMini(4,30,"V  = 4 et q = 3 :",1);
									PrintMini(8,32,"0",1);
									PrintMini(4,38,"Vn = V  * q    = 4 * 3",1);
									PrintMini(29,40,"0",1);
									PrintMini(52,36,"n-0",1);
									PrintMini(97,36,"n",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 4:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"S'il faut conjecturer sur les",1);
									PrintMini(4,22,"variations de la suite Un,",1);
									PrintMini(4,30,"il faut comparer les premiers",1);
									PrintMini(4,38,"termes de la suite et emettre",1);
									PrintMini(4,46,"une hypothese",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : U =1, U =4, U =9",1);
									PrintMini(49,16,"0",1);
									PrintMini(71,16,"1",1);       
									PrintMini(95,16,"2",1);   
									PrintMini(4,22,"On conjecture que la suite",1);
									PrintMini(4,30,"Un est croissante",1);
									break;
								
								case 3:
									PrintMini(4,14,"S'il faut trouver le sens de",1);
									PrintMini(4,22,"variation de la suite Un,",1);
									PrintMini(4,30,"il faut utiliser une des",1);
									PrintMini(4,38,"techniques enoncees dans la",1);
									PrintMini(4,46,"partie \"suites monotones\"",1);
									break;
								
								case 4:
									PrintMini(4,15,"Exemple : U    = Un + 3",1);
									PrintMini(49,17,"n+1",1);
									PrintMini(4,24,"U    - Un = Un + 3 - Un = 3 ",1);
									PrintMini(8,26,"n+1",1);
									PrintMini(4,34,"D'ou U    - Un > 0",1);
									PrintMini(27,36,"n+1",1);
									PrintMini(4,44,"Donc Un est croissante",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
						case 5:
							switch(position_question)
							{
								case 1:
									PrintMini(4,14,"S'il faut conjecturer sur la",1);
									PrintMini(4,22,"convergence de la suite Un,",1);
									PrintMini(4,30,"il faut analyser les premiers",1);
									PrintMini(4,38,"termes de la suite et emettre",1);
									PrintMini(4,46,"une hypothese",1);
									break;
									
								case 2:
									PrintMini(4,14,"Exemple : U =2.994, U =2.996",1);
									PrintMini(49,16,"0",1);
									PrintMini(87,16,"1",1);    
									PrintMini(4,22,"U =2.997 ",1);
									PrintMini(8,24,"2",1);
									PrintMini(4,30,"On conjecture que la suite",1);
									PrintMini(4,38,"Un converge vers 3",1);
									break;
								
								case 3:
									PrintMini(4,14,"S'il faut trouver la limite de",1);
									PrintMini(4,22,"la suite Un, il faut utiliser",1);
									PrintMini(4,30,"les informations presentes",1);
									PrintMini(4,38,"dans l'enonce (comme son",1);
									PrintMini(4,46,"expression)",1);
									break;
								
								case 4:
									PrintMini(4,14,"Exemple : Un = 4 + (3/n)",1);
									affichage_limite(4,22,100,0);
									for(i = 0 ; i < 6 ; i++)ML_line(4,28+i,8,28+i,ML_WHITE);
									PrintMini(3,28,"n",1);
									PrintMini(20,22,"(3/n) = 0",1);
									PrintMini(4,38,"D'ou",1);
									affichage_limite(22,38,100,0);
									for(i = 0 ; i < 6 ; i++)ML_line(21,44+i,25,44+i,ML_WHITE);
									PrintMini(21,44,"n",1);
									PrintMini(38,38,"Un = 4 : Un converge",1);
									PrintMini(74,46,"vers 4",1);
									break;
								
								case 5:
									PrintMini(53,31,"Retour",1);
									break;
							}
							break;
							
					
					}

					affichage_questions = 0;
				}
	
			ML_display_vram();
	
			}
			
			clear();
			
			if(IsKeyUp(KEY_CTRL_F6))
			{
				for(i = 1 ; i < 18 ; i++)ML_line(1,i,127,i,ML_BLACK);
		
				PrintXY(10,6,"Suites : questions",1);
		
				question();
				
				case_question_suite(milieu);
				case_question(choix,milieu);
				affichage_question_suite(choix);	
				fleche_question(milieu,4);
			}
			
			permission_quitter = 0;
		}
		
		ML_display_vram();
	}
}

void case_question_suite(int milieu)
{
	int j = 0, a = 0;

	for(a = 1 ; a < 4 ; a++)for(j = 11 + 12 * a ; j < 22 + 12 * a ; j++)ML_line(6,j,45,j,ML_WHITE);
	
	if(milieu == 2)PrintMini(15,26,"Terme",0);
	if(milieu > 1 && milieu < 4)PrintMini(7,62 - 12*milieu, "Suite ari.", 0);
	if(milieu > 1 && milieu < 5)PrintMini(7,74 - 12*milieu, "Suite geo.", 0);
	if(milieu > 2 && milieu < 6)PrintMini(9,86 - 12*milieu, "Variation", 0);
	if(milieu > 3 && milieu < 7)PrintMini(9,98 - 12*milieu, "Converg.", 0);
}

void affichage_question_suite(int choix)
{
	int i = 0;
	
	for(i = 0 ; i < 35 ; i++)ML_line(52,23+i,104,23+i,ML_WHITE);
	
	switch(choix)
	{
		case 1 :
			PrintMini(54,26,"Calculer les",0);
			PrintMini(54,32,"1er termes",0);
			PrintMini(54,38,"de la suite",0);
			break;
		
		case 2 :
			PrintMini(54,26,"Definir",0);
			PrintMini(54,32,"la suite",0);
			PrintMini(54,38,"arithmetique",0);
			break;
			
		case 3 :
			PrintMini(54,26,"Definir",0);
			PrintMini(54,32,"la suite",0);
			PrintMini(54,38,"geometrique",0);
			break;
	
		case 4 :
			PrintMini(54,26,"Etudier les",0);
			PrintMini(54,32,"variations",0);
			PrintMini(54,38,"de la suite",0);
			break;
			
		case 5 :
			PrintMini(54,26,"Etudier la",0);
			PrintMini(54,32,"convergence",0);
			PrintMini(54,38,"de la suite",0);
			break;
	}
	
}